var disableValidatorPostfix = "_SectionIncrement_";
var disableValidatorPrefix = "DoNotValidate_";
var repeatingPostfix = "_Repeating_";
//////////////// ML //////////////
var repeatingElementPostfix = "-";
/////////////////////////////////

var count = 0;
var fieldIndex = 0;
var sign = "-";
var disableValidators = "disableValidators";

function GetLookupUri() {
    try {
        if (lookupUri != undefined) {
            return lookupUri;
        }
    } catch (err) { }

    return 'http://localhost/ego.filler.ws/lookup.aspx';
}

$.fn.InitHierarchicallyTree = function () {
    //ak su nejake hierarchicke componenty
    var hierarchicalTries = this.find(".hierarchicalTree");

    if (hierarchicalTries.length == 0) {
        return this;
    }

    //ziskanie adresy sluzby
    var url = GetLookupUri();

    //nacitanie adresy sluzby
    var loadChildren = function (node, level, nodeId, callback, lookupID, lookupSource) {
        var data = 'id=' + lookupID + '&lookupSource=' + lookupSource;
        if (nodeId != null) {
            data += "&parentId=" + nodeId;
        }

        $.ajax({
            async: true,
            url: url,
            data: data,
            dataType: "jsonp"
        }).done(function (data) {
            if (data.iTotalDisplayRecords == 0) {
                node.has_children = false;
                node.busy = false;
                delete node.children[0];
            }
            else {

                for (var i = 0; i < data.aaData.length; i++) {
                    node.children.push({
                        id: data.aaData[i][0],
                        title: data.aaData[i][1],
                        has_children: true,
                        level: node.level + 1,
                        children: []
                    });
                }
            }

            callback(node);
        })
        .error(function (data) {

        });
    };

    hierarchicalTries.each(function () {
        var hierarchicalTree = $(this);
        if (!hierarchicalTree.hasClass("chosentree")) {
            hierarchicalTree.addClass("chosentree");
        }

        var spanLookupConfiguration = hierarchicalTree.siblings("span.lookupConfiguration");
        var remoteSourceIdentifier = spanLookupConfiguration.children("span.remoteSourceIdentifier");
        var remoteLookupCode = spanLookupConfiguration.children("span.remoteLookupCode");
        var remoteSourceId = spanLookupConfiguration.children("span.lookupComponentId");
        var remoteSourceName = spanLookupConfiguration.children("span.lookupComponentName");

        if (remoteSourceIdentifier.length > 0 && remoteLookupCode.length > 0 && remoteSourceId.length > 0 && remoteSourceName.length > 0) {
            hierarchicalTree.chosentree({
                inputId: remoteSourceId[0].innerHTML,
                inputName: remoteSourceName[0].innerHTML,
                width: 500,
                deepLoad: true,
                showtree: true,
                load: function (node, callback) {
                    var nodeId = node.id == 0 ? null : node.id;
                    loadChildren(node, 0, nodeId, callback, remoteLookupCode[0].innerHTML, remoteSourceIdentifier[0].innerHTML);
                }
            });
        }
    });

    return this;
}

$.fn.InitHelp = function () {

    var InfoDialog = function() {
        var infoIcon = $(this);
        var modal = infoIcon.find(".dialog-modal");
        modal.dialog({
            position: {
                my: "left",
                at: "right",
                of: infoIcon,
                offset: "20 20"
            },
            open: function (event, ui) {
                infoIcon.unbind('mouseout');
                infoIcon.mouseout(function () {
                    try {
                        var target = $(event.target);
                        target.dialog('destroy');
                        target.appendTo(modal);
                        
                    } catch (e) {

                    } 
                });
                infoIcon.mousedown(function () {
                    infoIcon.unbind('mouseout');
                });
            },
            close: function (event, ui) {
                var target = $(event.target);
                target.dialog('destroy');
                target.appendTo(modal);
            }
        });
    };

    this.find(".info").mouseover(InfoDialog);

    return this;
}

$.fn.InitMultiCombobox = function () {
    var elements = $(".multiCombobox");
    if (elements.length > 0) {
        elements.multiselect();
    }
}

$.fn.DeleteMultiCombobox = function () {
    var elements = $(".multiCombobox");
    if (elements.length > 0) {
        elements.multiselect("destroy");
    }
}

$.fn.InitRemoteCombobox = function () {
    var elements = this.find(".remoteComboBox");
    var layoutRow = this;
    if (elements.length > 0) {
        elements.change(function () {
            var remoteComboBox = $(this);

            if (remoteComboBox.attr("fieldID") == undefined) {
                RemoteComboboxNew(remoteComboBox, layoutRow);
            }
            else {
                RemoteComboboxOld(remoteComboBox, layoutRow);
            }
        });
    }

    return this;
}

function RemoteComboboxNew(remoteComboBox, layoutRow) {
    var remoteComboboxId = remoteComboBox.attr("id");
    var repetionsSectionId = "";
    var repetionsSectionIdPostfix = "";
    var idParts = remoteComboBox.attr("id").split('-');
    if (idParts.length > 1) {
        repetionsSectionId = idParts[idParts.length - 1];
        remoteComboboxId = idParts[0];
        repetionsSectionIdPostfix = "-" + repetionsSectionId;
    }

    //najdi najblizsi skryty span, ktory obsahuje informaciu o remoteComboboxe 
    var spanLookupConfiguration = remoteComboBox.siblings("span.lookupConfiguration");
    var spanLookupComponentId = spanLookupConfiguration.children("span.lookupComponentId");
    var spanFieldId = spanLookupConfiguration.children("span.fieldId");

    if (spanLookupConfiguration.length > 0) {
        if (spanLookupComponentId.length > 0 && spanFieldId.length > 0 && spanLookupComponentId[0].innerHTML == remoteComboboxId) {
            var fieldId = spanFieldId[0].innerHTML + repetionsSectionIdPostfix;
            var fields = layoutRow.find("#" + fieldId);
            fields.first().val(remoteComboBox.val());
        }
    }
}

//todo obsolete
function RemoteComboboxOld(remoteComboBox, layoutRow) {
    var repetionsSectionId = "";
    var idParts = remoteComboBox.attr("id").split('-');
    if (idParts.length > 1) {
        repetionsSectionId = idParts[idParts.length - 1];
    }

    var fieldId = remoteComboBox.attr("fieldID");
    var fields = layoutRow.find("input[" + "fieldid" + "='" + fieldId + "']");
    if (repetionsSectionId != "") {
        fields.each(function () {
            var field = $(this);
            var idPartsFiles = field.attr("id").split('-');
            if (idPartsFiles[idPartsFiles.length - 1] == repetionsSectionId) {
                fields = field;
            }
        });
    }

    if (fields.length == 0) {
        fields = layoutRow.find("textarea[" + "fieldid" + "='" + fieldId + "']");
        if (repetionsSectionId != "") {
            fields.each(function () {
                var field = $(this);
                var idPartsFiles = field.attr("id").split('-');
                if (idPartsFiles[idPartsFiles.length - 1] == repetionsSectionId) {
                    fields = field;
                }
            });
        }
    }

    if (fields.length > 0)
        fields.first().val(remoteComboBox.val());
}

$.fn.InitSectionAccordion = function () {
    this.find(".caption").click(function () {
        var caption = $(this);
        var layoutRowContent = caption.next(".columns");
        //var layoutRow = layoutRowContent.parent();
        //var isEmpty = layoutRow.attr('isEmpty');

        //if (isEmpty == 'true'){             
        //    return;
        //}

        var arrowSpan = caption.children("span.ui-icon");
        arrowSpan.toggleClass("ui-icon-carat-1-n").toggleClass("ui-icon-carat-1-s");
        //layoutRowContent.slideToggle(0);
        if (arrowSpan.hasClass("ui-icon-carat-1-n")) {
            layoutRowContent.show();
        } else if (arrowSpan.hasClass("ui-icon-carat-1-s")) {
            layoutRowContent.hide();
        }
    });

    return this;
};

// Skok na pozadovany element s pripadnym rozbalenim zbalenych sekcii interakciou chybovej hlasky
function expandLayoutRowsAndFocus() {
    $('.error[for], .warning[for]').live("focus click", function (e) {
        e.preventDefault();

        var closestLayotRow = $("[id='" + this.htmlFor + "']").closest('.layoutRow');
        var firstCaption;

        if (closestLayotRow[0]) {
            firstCaption = $(closestLayotRow[0]).find('.caption').first();

            if (firstCaption.children("span.ui-icon").hasClass("ui-icon-carat-1-s"))
                firstCaption.click();
        }

        while (closestLayotRow[0]) {
            if (closestLayotRow[0].parentElement) {
                closestLayotRow = $(closestLayotRow[0].parentElement).closest('.layoutRow');

                if (closestLayotRow[0]) {
                    firstCaption = $(closestLayotRow[0]).find('.caption').first();

                    if (firstCaption.children("span.ui-icon").hasClass("ui-icon-carat-1-s"))
                        firstCaption.click();
                }
            }
        }

        $("[id='" + this.htmlFor + "']").focus();
    });
}

$.fn.RemoveDatePickerClass = function () {
    this.find(".datepicker, .datepickerISO, .timepicker, .datetimepicker").removeClass("hasDatepicker");

    return this;
};

$.fn.InitDatePicker = function () {
    this.find(".datepicker").datepicker();

    return this;
};

$.fn.InitDateTimeControl = function () {
    this.find(".datetimepicker").datetimepicker();

    return this;
};

$.fn.InitPopUpDialog = function () {
    var elements = this.find(".remoteLookup");

    // vyhybka starej a novej verzie scriptu
    if (elements.length > 0) {
        RemoteLookupNew(this);
    }
    else {
        RemoteLookupOld(this);
    }

    return this;
}

function GetFormLanguage() {
    return $('meta[name=language]').attr("content");
}

//todo obsolete
function RemoteLookupOld(layoutRow) {
    layoutRow.find("div[LookupDetail]").dialog({
        autoOpen: false,
        modal: true
    });

    layoutRow.find("[LookupButton]").click(function () {
        var lookupBtn = $(this);
        var attributeName = "fieldID";
        var fieldId = lookupBtn.attr(attributeName);
        var lookupSource = lookupBtn.attr('lookupSource');
        fieldIndex = $("span.lookupbutton[" + attributeName + "='" + fieldId + "']").index(this);
        var nonPostfixFieldID = fieldId.split(disableValidatorPostfix)[0];
        var dialog = $("[LookupForm][" + attributeName + "='" + nonPostfixFieldID + "']").eq(0);
        dialog.attr("fieldID", fieldId);
        dialog.attr("lookupSource", lookupSource);
        dialog.closest(".ui-dialog").addClass("lookup-dialog");
        dialog.dialog("open");
    });

    layoutRow.find("[FieldInfo]").mouseover(function () {
        var fieldInfo = $(this);
        var attributeName = "fieldID";
        var infoIcon = fieldInfo.children("span");
        var targetField = infoIcon.parent().siblings("[class='fieldContent']").children("input[id]");
        var targetWidth = targetField.width();
        var fieldId = fieldInfo.attr(attributeName);
        var nonPostfixFieldID = fieldId.split(disableValidatorPostfix)[0];
        var fieldInfoIndex = $("[FieldInfo][" + attributeName + "='" + nonPostfixFieldID + "']").index(this);
        var infoText = $("input[LookupDetailInfo][" + attributeName + "='" + fieldId + "']").eq(fieldInfoIndex).val();
        $("div[LookupDetail][" + attributeName + "='" + nonPostfixFieldID + "']").text(infoText);
        var modal = $("div[LookupDetail][" + attributeName + "='" + nonPostfixFieldID + "']").eq(0);
        modal.dialog({
            autoOpen: true,
            modal: false,
            position: { my: "left bottom-3", at: "left top", of: targetField },
            width: targetWidth,
            open: function (event, ui) {
                infoIcon.unbind('mouseout');
                infoIcon.mouseout(function () {
                    var target = $(event.target);
                    target.dialog('close');
                    target.appendTo(modal);
                });
                infoIcon.mousedown(function () {
                    infoIcon.unbind('mouseout');
                });
            },
            close: function (event, ui) {
                var target = $(event.target);
                target.dialog('close');
                target.appendTo(modal);
            }
        });
    });

    layoutRow.find("[LookupForm]").dialog({
        autoOpen: false,
        height: 350,
        width: 420,
        modal: true,
        buttons: {
            "OK": SubmitLookup,
            "Zrušiť": function () {
                $(this).dialog("close");
            }
        },
        open: OpenLookup
    });

    switch (GetFormLanguage()) {
        case 'en':
            layoutRow.find("[LookupForm]").dialog({
                buttons: {
                    "OK": SubmitLookup,
                    "Cancel": function () {
                        $(this).dialog("close");
                    }
                }
            });
            break;

        default: // sk a default
            layoutRow.find("[LookupForm]").dialog({
                buttons: {
                    "OK": SubmitLookup,
                    "Zrušiť": function () {
                        $(this).dialog("close");
                    }
                }
            });
    }

    function SubmitLookup() {
        var lookup = $(this);
        var attributeName = "fieldID";
        var fieldId = lookup.attr(attributeName);
        var nonPostfixFieldId = fieldId.split(disableValidatorPostfix)[0];
        var anSelected = fnGetSelected(oTable);
        var field = $("[LookupField][" + attributeName + "='" + fieldId + "']").eq(fieldIndex);
        var turned = "turned";
        var lookupDetailInfo = $("input[LookupDetailInfo][" + attributeName + "='" + fieldId + "']").eq(fieldIndex);
        var lookupFieldValue = $("input[LookupFieldValue][" + attributeName + "='" + fieldId + "']").eq(fieldIndex);
        var aData;
        if (anSelected.length > 0) {
            var data;
            aData = oTable.fnGetData(anSelected[0]);
            if (field.hasClass(turned)) {
                field.val(aData[1]);
                data = aData[0];
                lookupDetailInfo.val(data);
                lookupFieldValue.val(data);
            } else {
                field.val(aData[0]);
                data = aData[1];
                lookupDetailInfo.val(data);
                lookupFieldValue.val(data);
            }
        }
        else {
            aData = oTable.fnGetData(anSelected[0]);
            field.val(field.hasClass(turned) ? aData[0][1] : aData[0][0]);
            lookupDetailInfo.val(aData[1]);
        }
        lookup.attr(attributeName, nonPostfixFieldId);
        field.focus();
        lookup.dialog("close");
    }

    function OpenLookup() {
        var lookup = $(this);
        var lookupId = lookup.attr('lookupID');
        var lookupSource = lookup.attr('lookupSource');

        oTable = lookup.find("table[id^='LookupTable']").dataTable({
            "bAutoWidth": true,
            "bFilter": true,
            "bServerSide": true,
            "bJQueryUI": true,
            "bProcessing": true,
            "bLengthChange": false,
            "iDisplayLength": 10,
            "bPaginate": true,
            "bInfo": false,
            "bRetrieve": true,
            "sAjaxSource": GetLookupUri() + '?id=' + lookupId + '&lookupSource=' + lookupSource + '&callback=?',
            "aoColumns": [{ "sName": "Kod" }, { "sName": "Hodnota" }]
        });

        oTable.fnFilterOnReturn();

        lookup.find("[id^='LookupTable'][id$='_filter']").hide();
        lookup.find("[id^='FilterButton']").button().click(function () {
            oTable.fnFilter($(this).prev().val());
        });

        lookup.find("table[id^='LookupTable'] tbody").click(function (event) {
            $(oTable.fnSettings().aoData).each(function () {
                $(this.nTr).removeClass('row_selected');
            });
            $(event.target.parentNode).addClass('row_selected');
        });
    }
}

function RemoteLookupNew(layoutRow) {

    var elements = layoutRow.find(".remoteLookup");
    elements.each(function () {
        var remoteLookup = $(this);

        var lookupDetailInfo = remoteLookup.siblings('.LookupDetailInfo');
        var lookupInfo = remoteLookup.parent().siblings(".fieldInfo");
        var lookupFieldValue = null;
        lookupDetailInfo.val("");

        //Nacitanie hodnot z konfiguracnej sekcie
        var spanLookupConfiguration = remoteLookup.siblings("span.lookupConfiguration");
        var spanLookupComponentId = spanLookupConfiguration.children("span.lookupComponentId");
        var spanFieldId = spanLookupConfiguration.children("span.fieldId");
        var remoteSourceIdentifier = spanLookupConfiguration.children("span.remoteSourceIdentifier");
        var remoteLookupCode = spanLookupConfiguration.children("span.remoteLookupCode");

        var closestLayoutRow = remoteLookup.closest(".layoutRow");

        if (spanFieldId.length > 0) {
            lookupFieldValue = closestLayoutRow.find('[id|="' + spanFieldId.html() + '"]');
        }

        //najdenie lookup Formu
        var lookupForms = $(".LookupForm");
        var lookupForm = null;
        lookupForms.each(function () {
            var lookupFormLocal = $(this);
            var spanLookupFormConfiguration = lookupFormLocal.children("span.lookupConfiguration");
            var spanLookupFormComponentId = spanLookupFormConfiguration.children("span.lookupComponentId");
            if (spanLookupFormComponentId[0].innerHTML == spanLookupComponentId[0].innerHTML) {
                lookupForm = lookupFormLocal;
                return false;
            }
        });

        //najdenie lookup detailu
        var lookupDetails = $(".LookupDetail");
        var lookupDetail = null;
        var lookupTable = null;
        lookupDetails.each(function () {
            var lookupDetailLocal = $(this);
            var spanLookupDetailConfiguration = lookupDetailLocal.children("span.lookupConfiguration");
            var spanLookupDetailComponentId = spanLookupDetailConfiguration.children("span.lookupComponentId");
            if (spanLookupDetailComponentId[0].innerHTML == spanLookupComponentId[0].innerHTML) {
                lookupDetail = lookupDetailLocal;
                return false;
            }
        });

        //nastavnie lookup table
        if (lookupForm != null) {
            lookupTable = lookupForm.find('.LookupTable');
        }

        if (lookupDetail!= null && lookupDetail.length > 0) {
            lookupDetail.dialog({
                autoOpen: false,
                modal: true
            });
        }

        remoteLookup.siblings(".lookupbutton").click(function () {
            lookupForm.dialog({
                autoOpen: false,
                height: 350,
                width: 420,
                modal: true,
                open: function (args, callback) {
                    OpenLookup(lookupForm, lookupTable, remoteSourceIdentifier[0].innerHTML, remoteLookupCode[0].innerHTML);
                }
            });
            lookupForm.closest(".ui-dialog").addClass("lookup-dialog");
            lookupForm.dialog("open");
        });

        switch (GetFormLanguage()) {
            case 'en':
                remoteLookup.siblings(".lookupbutton").click(function () {
                    lookupForm.dialog({
                        buttons: {
                            "OK": function (args, callback) {
                                SubmitLookup(lookupForm, remoteLookup, lookupDetailInfo, lookupFieldValue);
                            },
                            "Cancel": function () {
                                $(this).dialog("close");
                            }
                        }
                    });
                });
                break;

            default: // sk a default
                remoteLookup.siblings(".lookupbutton").click(function () {
                    lookupForm.dialog({
                        buttons: {
                            "OK": function (args, callback) {
                                SubmitLookup(lookupForm, remoteLookup, lookupDetailInfo, lookupFieldValue);
                            },
                            "Zrušiť": function () {
                                $(this).dialog("close");
                            }
                        }
                    });
                });
        }

        if (lookupInfo.length > 0) {
            lookupInfo.mouseover(function () {
                var infoIcon = lookupInfo.children("span");
                var targetWidth = remoteLookup.width();
                var infoText = lookupDetailInfo.val();
                lookupDetail.children('.LookupDetailInfoText').text(infoText);

                lookupDetail.dialog({
                    autoOpen: true,
                    modal: false,
                    position: { my: "left bottom-3", at: "left top", of: remoteLookup },
                    width: targetWidth,
                    open: function (event, ui) {
                        infoIcon.unbind('mouseout');
                        infoIcon.mouseout(function () {
                            var target = $(event.target);
                            target.dialog('close');
                            target.appendTo(lookupDetail);
                        });
                        infoIcon.mousedown(function () {
                            infoIcon.unbind('mouseout');
                        });
                    },
                    close: function (event, ui) {
                        var target = $(event.target);
                        target.dialog('close');
                        target.appendTo(lookupDetail);
                    }
                });
            });
        }

    });

    function SubmitLookup(lookupForm, field, lookupDetailInfo, lookupFieldValue) {
        var anSelected = fnGetSelected(oTable);
        var turned = "turned";
        var aData;
        if (anSelected.length > 0) {
            var data;
            aData = oTable.fnGetData(anSelected[0]);
            if (field.hasClass(turned)) {
                field.val(aData[1]);
                data = aData[0];
                lookupDetailInfo.val(data);
                if (lookupFieldValue != null)
                    lookupFieldValue.val(data);
            } else {
                field.val(aData[0]);
                data = aData[1];
                lookupDetailInfo.val(data);
                if (lookupFieldValue != null)
                    lookupFieldValue.val(data);
            }
        }
        else {
            aData = oTable.fnGetData(anSelected[0]);
            field.val(field.hasClass(turned) ? aData[0][1] : aData[0][0]);
            lookupDetailInfo.val(aData[1]);
        }

        field.focus();
        lookupForm.dialog("close");
    }

    function OpenLookup(lookupForm, lookupTable, lookupSource, lookupId) {

        switch (GetFormLanguage()) {
            case 'en':
                oTable = lookupTable.dataTable({
                    "bAutoWidth": true,
                    "bFilter": true,
                    "bServerSide": true,
                    "bJQueryUI": true,
                    "bProcessing": true,
                    "bLengthChange": false,
                    "iDisplayLength": 10,
                    "bPaginate": true,
                    "bInfo": false,
                    "bRetrieve": true,
                    "sAjaxSource": GetLookupUri() + '?id=' + lookupId + '&lookupSource=' + lookupSource + '&callback=?',
                    "aoColumns": [{ "sName": "Code" }, { "sName": "Value" }],
                    "oLanguage": {
                        "sEmptyTable": "No data available in table",
                        "sInfo": "Showing _START_ to _END_ of _TOTAL_ entries",
                        "sInfoEmpty": "Showing 0 to 0 of 0 entries",
                        "sInfoFiltered": "(filtered from _MAX_ total entries)",
                        "sInfoPostFix": "",
                        "sInfoThousands": ",",
                        "sLengthMenu": "Show _MENU_ entries",
                        "sLoadingRecords": "Loading...",
                        "sProcessing": "Processing...",
                        "sSearch": "Search:",
                        "sZeroRecords": "No matching records found",
                        "oPaginate": {
                            "sFirst": "First",
                            "sLast": "Last",
                            "sNext": "Next",
                            "sPrevious": "Previous"
                        },
                        "oAria": {
                            "sSortAscending": ": activate to sort column ascending",
                            "sSortDescending": ": activate to sort column descending"
                        }
                    }
                });
                break;

            default: // sk a default
                oTable = lookupTable.dataTable({
                    "bAutoWidth": true,
                    "bFilter": true,
                    "bServerSide": true,
                    "bJQueryUI": true,
                    "bProcessing": true,
                    "bLengthChange": false,
                    "iDisplayLength": 10,
                    "bPaginate": true,
                    "bInfo": false,
                    "bRetrieve": true,
                    "sAjaxSource": GetLookupUri() + '?id=' + lookupId + '&lookupSource=' + lookupSource + '&callback=?',
                    "aoColumns": [{ "sName": "Kod" }, { "sName": "Hodnota" }],
                    "oLanguage": {
                        "sEmptyTable": "Nie sú k dispozícii žiadne dáta",
                        "sInfo": "Záznamy _START_ až _END_ z celkom _TOTAL_",
                        "sInfoEmpty": "Záznamy 0 až 0 z celkom 0 ",
                        "sInfoFiltered": "(vyfiltrované spomedzi _MAX_ záznamov)",
                        "sInfoPostFix": "",
                        "sInfoThousands": ",",
                        "sLengthMenu": "Zobraz _MENU_ záznamov",
                        "sLoadingRecords": "Načítavam...",
                        "sProcessing": "Spracúvam...",
                        "sSearch": "Hľadať:",
                        "sZeroRecords": "Nenašli sa žiadne vyhovujúce záznamy",
                        "oPaginate": {
                            "sFirst": "Prvá",
                            "sLast": "Posledná",
                            "sNext": "Nasledujúca",
                            "sPrevious": "Predchádzajúca"
                        },
                        "oAria": {
                            "sSortAscending": ": aktivujte na zoradenie stĺpca vzostupne",
                            "sSortDescending": ": aktivujte na zoradenie stĺpca zostupne"
                        }
                    }
                });
        }

        oTable.fnFilterOnReturn();

        var filterButton = lookupForm.find(".FilterButton");
        var lookupTableTbody = lookupTable.find("tbody");
        filterButton.unbind("click");
        lookupTableTbody.unbind("click");

        lookupForm.find(".dataTables_filter").hide();
        filterButton.click(function () {
            oTable.fnFilter($(this).prev().val());
        });

        lookupTableTbody.click(function (event) {
            $(oTable.fnSettings().aoData).each(function () {
                $(this.nTr).removeClass('row_selected');
            });
            $(event.target.parentNode).addClass('row_selected');
        });
    }
}

function jsonLookupCallback(json, fieldId) {
    var options = '';

    $.each(json, function (key, val) {
        options += '<option value="' + val.optionValue + '">' + val.optionDisplay + '</option>';
    });

    $("select#" + fieldId + "SelectLookup").html(options);
}

$.fn.ClearFormElements = function () {
    this.find(':input').each(function () {
        var element = $(this);
        switch (this.type) {
            case 'password':
            case 'text':
            case 'textarea':
            case 'select-multiple':
                element.val('');
                break;
            case 'checkbox':
            case 'radio':
                this.checked = false;
                break;
        }

        var errorClass = "error";
        if (element.hasClass(errorClass)) {
            element.removeClass(errorClass);
        }
    });

    this.find('textarea').each(function () {
        $(this).html("");
    });
    this.find('select').each(function () {
        $(this).val("");
    });

    return this;
};

$.fn.ReinitRadioDefaultCheck = function () {
    this.find(':input').each(function () {
        switch (this.type) {
        case 'radio':
            var input = $(this);
            var defaultVal = input.attr('default');
            if (defaultVal == 'true') {
                this.checked = true;
                input.click();
            }
        }
    });

    return this;
};

$.fn.ResetRepetitionSection = function () {
    this.find('.layoutRow.repeatingSection').remove();
    this.find('.layoutRow.hiddenSection').toggleClass("hiddenSection");
    this.find('div[id^=repetitionCommands]').show();
    this.find('span[id^=removeSectionlayoutRow]').hide();

    return this;
};

function cleanSectionID(layoutRowID) {
    var regEx = new RegExp(repeatingPostfix + "\\d+$");
    return layoutRowID.replace(regEx, '');
}

function GetRepeatingSections(repeatSection) {
    var sections;
    var filterSection = [];

    if ($(repeatSection).hasClass("closeButton") == true) {
        var layoutRow = $(repeatSection).closest('div[id^=layoutRow]');
        var layoutRowId = layoutRow.attr("ID").split('_')[0];

        sections = $('div[id^=' + layoutRowId + ']');

        sections.each(function () {
            if (cleanSectionID($(this).attr('ID')) == layoutRowId)
                filterSection.push($(this));
        });
    } else {
        var cleanId = cleanSectionID(parseId(repeatSection, 'addSection'));
        sections = $('div[id^=' + cleanId + ']');

        sections.each(function () {
            if (cleanSectionID($(this).attr('ID')) == cleanId)
                filterSection.push($(this));
        });
    }

    return $($.map(filterSection, function (el) { return $.makeArray(el) }));
}

function IncrementDecrementSectionId(layoutRowCopy) {
    var repeatSection = layoutRowCopy[0];
    if (repeatSection == undefined) { repeatSection = layoutRowCopy; }
    var sections = GetRepeatingSections(repeatSection);

    if (sections.first()[0]) {
        $(sections.first()[0]).attr("ID", cleanSectionID($(sections.first()[0]).attr("ID")));
    }

    var i = 0;

    sections.slice(1).each(function () {
        var section = $(this);

        section.attr("ID", GetIncrementalValue(section.attr("ID"), ++i));
        section.addClass("repeatingSection");
    });
};

function IncrementDecrementInnerRepeatingIds(layoutRowCopy) {
    $(layoutRowCopy).find('div[id]').each(function () {
        IncrementDecrementSectionId($(this));
    });
}

$.fn.IncrementFieldIds = function () {
    var layoutRow = this;
    layoutRow.find('[ID].datepicker, [ID]:input, [ID].daterangepickerdiv').each(function () {
        IncrementElements(layoutRow, $(this), ["id", "name"]);
    });

    return layoutRow;
};

function IncrementElements(layoutRow, copyElement, attributes) {
    var attributeName = attributes[0];
    var oldId = copyElement.attr(attributeName);
    oldId = getOriginalId(oldId, sign);
    var selector = "[" + attributeName + "|='" + oldId + "']";
    var elements = $("#main").find(selector);

    if (elements.length > 0) {
        var suffix = "";

        switch (copyElement[0].type) {
        case 'checkbox':
        case 'radio':
            var countRadios = layoutRow.find(selector).length;
            var countGroups = elements.length / countRadios;
            for (var i = 0; i < countGroups; i++) {
                var start = i * countRadios;
                elements.slice(start, start + countRadios).each(function() {
                    var element = $(this);
                    if (i > 0) {
                        suffix = sign + i;
                    }

                    SetAttributeFor(element, oldId, suffix);
                    for (a = 0; a < attributes.length; a++) {
                        SetAttribute(element, attributes[a], suffix);
                    }
                });
            }
            break;
        default:
            i = 0;
            var firtsElement = elements.first();
            SetAttributeFor(firtsElement, oldId, suffix);
            for (var a = 0; a < attributes.length; a++) {
                SetAttribute(firtsElement, attributes[a], suffix);
            }

            elements.slice(1).each(function() {
                var element = $(this);
                suffix = sign + ++i;
                SetAttributeFor(element, oldId, suffix);
                for (a = 0; a < attributes.length; a++) {
                    SetAttribute(element, attributes[a], suffix);
                }
            });
        }

        var lastElement = elements.slice(elements.length - 1);
        if (lastElement != copyElement) {
            CopyValidationRules(oldId, lastElement);
        }
        CopyValidationRules(oldId, copyElement);
    }
}

function SetAttribute(input, attributeName, suffix) {
    var value = input.attr(attributeName);
    if (value != null) {
        value = getOriginalId(value, sign);

        input.attr(attributeName, value + suffix);
    }
}

function getOriginalId(value, sign) {
    var index = value.indexOf(sign);
    if (index > -1) {
        value = value.substring(0, index);
    }

    return value;
}

function SetAttributeFor(element, oldId, suffix) {
    var attributeName = "for";
    var selectorFor = "[" + attributeName + "|='" + oldId + "']";
    var label = element.closest('div').find(selectorFor);
    if (label != undefined) {
        SetAttribute(label, attributeName, suffix);
    }
}

function CopyValidationRules(oldId, copyElement) {
    if (copyElement.attr("name")) {
        var element = $('#' + oldId);
        var attributeName = "name";
        var elementName = element.attr(attributeName);
        if (elementName != null) {
            var backUpElementName = element[0].name;
            var backUpCopyElement = copyElement[0].name;
            element[0].name = element[0].name.replace(disableValidatorPrefix, '');
            copyElement[0].name = copyElement[0].name.replace(disableValidatorPrefix, '');
            var rules = element.rules();

            if (element[0] != copyElement[0])
                element[0].name = backUpElementName;

            element = element[0];
            var newRules = {};
            var newMessages = {};
            var settings = $.data(element.form, 'validator').settings;
            for (var method in rules) {
                var name = method.replace(elementName, copyElement.attr(attributeName));
                var validationObject = settings.messages[element.name.replace(disableValidatorPrefix, '')];
                if (validationObject != null) {
                    newRules[name] = rules[method];
                    var messages = validationObject[method];
                    newMessages[name] = messages;
                    $.validator.addMethod(name, $.validator.methods[method]);
                }
            }
            newRules.messages = newMessages;
            copyElement.rules('add', newRules);
            copyElement[0].name = backUpCopyElement;
        }
    }
}

function GetIncrementalValue(value, sectionIncrement) {
    var regEx = new RegExp(repeatingPostfix + "\\d+$");
    var cleanVal = value.replace(regEx, '');
    ////// ML vrati povodnu ////
    //if (sectionIncrement == '')
    //    return cleanVal;
    ////////////////////////////
    return cleanVal + repeatingPostfix + sectionIncrement;
}

function ReindexAddressInput(value) {
    var index = value.indexOf(sign);
    if (index > 0) {
        value = value.substring(0, index);
    }

    var count = 0;
    var selector = value;
    var element = $('#' + selector);

    while (element[0] != undefined) {
        count = count + 1;
        selector = value + sign + count;
        element = $('#' + selector);
    }

    return selector;
}

function GetValueWithoutIncremental(value) {
    var regEx = new RegExp(repeatingPostfix + "\\d+$");
    return value.replace(regEx, '');
}

function IncrementItemDelegate(context, sectionIncrement) {
    var attributeName = "name";
    context.attr(attributeName, GetIncrementalValue(context.attr(attributeName), sectionIncrement));
}

$.fn.ToggleValidators = function (toggle) {
    var attributeName;
    if (toggle == false) {
        attributeName = "name";
        this.find('[ID]:input').each(function () {
            var input = $(this);
            input.attr(attributeName, input.attr(attributeName).replace(disableValidatorPrefix, ''));
        });
        attributeName = "for";
        this.find('label').each(function () {
            var input = $(this);
            input.attr(attributeName, input.attr(attributeName).replace(disableValidatorPrefix, ''));
        });
        this.find("[id^='layoutRow'][isempty='true']").ToggleValidators(true);
        this.find("div.layoutRow.hiddenSection").ToggleValidators(true);
    } else {
        attributeName = "name";
        this.find('[ID]:input').each(function () {
            var input = $(this);
            if (input.attr(attributeName).indexOf(disableValidatorPrefix) == -1)
                input.attr(attributeName, disableValidatorPrefix + input.attr(attributeName));

            input.focusout();
        });
        attributeName = "for";
        this.find('label').each(function () {
            var input = $(this);
            if (input.attr(attributeName).indexOf(disableValidatorPrefix) == -1)
                input.attr(attributeName, disableValidatorPrefix + input.attr(attributeName));
        });
    }
    return this;
};

$.fn.ToggleValidatorsStyle = function (toggle) {
    var disablevalidators = disableValidators;
    this.find('[ID]:input').each(function () {
        var input = $(this);
        if (toggle == false) {
            input.removeClass(disablevalidators);
        } else {
            input.addClass(disablevalidators);
        }
        input.focusout();
    });

    return this;
};

$.fn.HideSwitchSections = function (switchesToSections) {
    for (var oneSwitch in switchesToSections) {
        var trigger = $(oneSwitch);
        for (var i = 0; i < trigger.length; i++) {
            var currentTrigger = $(trigger[i]);
            if (!currentTrigger.is(":checked")) {
                var sectionsCollection = switchesToSections[oneSwitch];
                var context = GetContext(currentTrigger, sectionsCollection);
                for (section in sectionsCollection) {
                    var section = context.find(sectionsCollection[section]).eq(0);
                    var hiddensection = "hiddenSection";
                    if (section.hasClass('cell')) {
                        var sectionChild = section.children().first();
                        sectionChild.toggleClass(hiddensection, true);
                        sectionChild.ToggleValidators(true);
                    }
                    section.toggleClass(hiddensection, true);
                    section.ToggleValidators(true);
                }
            }
        }
    }

    return this;
};

$.fn.SwitchSections = function (switchesToSections, isCheckBoxList) {
    var context = $(this);
    var isShowAll;
    var hasVal;

    $('form').find(context.selector).each(function () {
        var actualContext = $(this);
        hasVal = false;
        for (var singleSwitch in switchesToSections) {
            isShowAll = false;
            var target = switchesToSections[singleSwitch];
            var trigger = actualContext.find(singleSwitch);
            for (var section in target) {
                if (isShowAll)
                    return;

                actualContext.find(target[section]).find('input, select, textarea').each(function () {
                    var element = $(this)[0];
                    if (element.type != 'radio' && element.value != '')
                        hasVal = true;
                });
                isShowAll = trigger.is('[readonly]') && !hasVal;
            }
        }

        if (!isShowAll) {
            for (singleSwitch in switchesToSections) {
                trigger = actualContext.find(singleSwitch);
                if (trigger.length == 0)
                    return this;

                trigger.click(function () {
                    if (isCheckBoxList == true)
                        switchCheckboxClicked(switchesToSections, this);
                    else
                        switchRadioClicked(switchesToSections, this);
                });
            }
        }
    });

    return this;
};

$.fn.ReinitializeConditionalRules = function () {
    var context = $(this);

    InitConditionalRules(context);

    return this;
};

function GetContext(currentclick, target) {
    return recur($(currentclick), target[0]);
}

function findParent(element) {
    var patt = new RegExp("^layoutRow[0-9]+$");
    var patt2 = new RegExp("^layoutRow[0-9]+_Repeating_[0-9]+$");
    var id = element[0].id;
    if (patt.test(id) || patt2.test(id) || id == "main") {
        return element;
    } else {
        return findParent(element.parent());
    }
}

function recur(element, target) {
    var f;
    var children = element[0].children;

    for (var i = 0; i < children.length; i++) {
        var child = children[i];
        if (child.id == "main") {
            return $("form");
        }
        if (child.children.length > 0) {
            var a = $(child).find(target);
            if (a.length > 0) {
                f = findParent(a.parent());
            } 
        }
    }

    if (f == null) {
        return recur(element.parent(), target);
    } else {
        return f;
    }
}

function customFunctionAfterSwitchSection(switchesToSections, currentclick) {
    // Override this function in custom p_PROJECT.js file
}

function switchRadioClicked(switchesToSections, currentclick) {
    for (var oneSwitch in switchesToSections) {
        var target = switchesToSections[oneSwitch];
        var context = GetContext(currentclick, target);
        oneSwitch = context.find(oneSwitch);

        for (var section in target) {
            section = context.find(target[section]);
            var sectionChild;
            var hiddensection = "hiddenSection";
            var cell = 'cell';
            if (oneSwitch[0] == currentclick) {
                if (section.hasClass(cell)) {
                    sectionChild = section.children().first();
                    sectionChild.toggleClass(hiddensection, false);
                    sectionChild.ToggleValidators(false);
                }
                section.toggleClass(hiddensection, false);
                section.ToggleValidators(false);
            } else {
                if (section.hasClass(cell)) {
                    sectionChild = section.children().first();
                    sectionChild.toggleClass(hiddensection, true);
                    sectionChild.ToggleValidators(true);
                }
                section.toggleClass(hiddensection, true);
                section.ToggleValidators(true);
            }

            $('[id^=' + GetValueWithoutIncremental(section.attr('id') + ']')).RemoveDatePickerClass();
            section.IncrementFieldIds();
            InitPickers();
        }
    }

    customFunctionAfterSwitchSection(switchesToSections, currentclick);
}

function switchCheckboxClicked(switchesToSections, currentclick) {
    var isCheckboxSelected = $(currentclick).is(':checked');
    var sectionsCollection = null;

    for (var sectionsKey in switchesToSections) {
        var target = switchesToSections[sectionsKey];
        var context = GetContext(currentclick, target);
        var oneSwitch = context.find(sectionsKey);
        if (oneSwitch[0] == currentclick) {
            sectionsCollection = target;
            break;
        }
    }

    if (sectionsCollection == null)
        return;

    for (var section in sectionsCollection) {
        section = context.find(sectionsCollection[section]).eq(0);
        var sectionChild;
        var hiddensection = "hiddenSection";
        var cell = 'cell';
        if (isCheckboxSelected) {
            if (section.hasClass(cell)) {
                sectionChild = section.children().first();
                sectionChild.toggleClass(hiddensection, false);
                sectionChild.ToggleValidators(false);
            }
            section.toggleClass(hiddensection, false);
            section.ToggleValidators(false);
        }
        else {
            if (section.hasClass(cell)) {
                sectionChild = section.children().first();
                sectionChild.toggleClass(hiddensection, true);
                sectionChild.ToggleValidators(true);
            }
            section.toggleClass(hiddensection, true);
            section.ToggleValidators(true);
        }
    }

    customFunctionAfterSwitchSection(switchesToSections, currentclick);
}

$.GetUrlParam = function (name) {
    var results = new RegExp('[\\?&]' + name + '=([^&#]*)').exec(window.location.href);

    if (results == null)
        return 0;

    return results[1] || 0;
}

/////////////////////////////// ML /////////////////////////////////////

function GetOnlyIncrementValue(value) {    //////////////////////////////////////////////////////////////////////////  rozsirenie

    var regEx = new RegExp(repeatingElementPostfix + "(\\d+)$")
    var cleanVal = regEx.exec(value);
    if (cleanVal == null)
        return '';
    else
        return parseInt(cleanVal[1]);
}

function getPagedSectionName(element) {  //////////////////////////////////////////////////////////////////////////  rozsirenie
    var lsecpg = $(element).closest('div.pageableSection');
    if (lsecpg != null)
        return lsecpg.attr('id');
    else
        return null;
}

function GetElementIncrementalValue(value, sectionIncrement) {
    var regEx = new RegExp(repeatingElementPostfix + "\\d+$");
    var cleanVal = value.replace(regEx, '');
    //// ML vrati povodnu ////
    if (sectionIncrement == '')
        return cleanVal;

    return cleanVal + repeatingElementPostfix + sectionIncrement;
}

///////////////////////////////////////////////////////////////////////