﻿var attachmentsDataArray = new Object();

function GetData(acceptEmptyForm) {

    if (acceptEmptyForm == undefined) {
        acceptEmptyForm = false;
    } 

    var formId = GetFormId();
    var xmlns = GetMetadataNamespace();
    var xml = '<' + formId + xmlns + '>';
    var hasMetadata = $("#mtd_formMetaData").length > 0;
    function processHtml() {
        var element = $(this);
        var isempty = 'isempty';

        if (!acceptEmptyForm && element.attr(isempty) !== undefined && element.attr(isempty) == "true")
            return;

        var name = 'name';
        var layoutRow = 'layoutRow';
        var firstInput;
        if (element.hasClass(layoutRow)) {
            firstInput = element.children("input:first");
            if (firstInput.attr(name) != 'Attachments') {
                if (element.hasClass('hiddenSection')) {
                    xml += '<' + disableValidatorPrefix + firstInput.attr(name) + '>';
                } else {
                    xml += '<' + firstInput.attr(name) + '>';
                }
            }
        }

        if (element.is(':input')) {
            if (element.is(':file') || element.is(':button') || element.attr('LookupDetailInfo') == "true")
                return;

            if (element.parent().hasClass(layoutRow))
                return;

            var attr = element.attr(name);
            if (attr !== undefined) {
                var index = attr.indexOf(sign);
                if (index > -1) {
                    attr = attr.substr(0, index);
                }
                var checked = ':checked';
                var val;
                if (element.is(':radio')) {
                    if (element.is(checked)) {
                        var cleanName = GetValueWithoutIncremental(attr);

                        xml += '<' + cleanName + '>' + element.val() + '</' + cleanName + '>';
                    }
                } else if (element.is(':checkbox')) {
                    if (element.is(checked)) {
                        if (!hasMetadata) {
                            xml += '<' + attr + '>' + ((element.hasClass("checkBox")) ? 1 : element.val()) + '</' + attr + '>';
                        } else {
                            xml += '<' + attr + '>' + ((element.hasClass("checkBox") && element.hasClass("xsd_boolean")) ? 1 : element.val()) + '</' + attr + '>';
                        }
                    } else {
                        if (element.hasClass("checkBox")) {
                            if (!hasMetadata) {
                                xml += '<' + attr + '>' + 0 + '</' + attr + '>';
                            } else {
                                if (element.hasClass("xsd_boolean")) {
                                    xml += '<' + attr + '>' + 0 + '</' + attr + '>';
                                }
                            }
                        }
                    }
                } else if (element.attr("multiple")) {
                    val = element.val() === null ? "" : element.val();
                    for (var i = 0, j = val.length; i < j; i++) {
                        xml += '<' + attr + '>' + HtmlEncode(val[i]) + '</' + attr + '>';
                    }
                } else {
                    val = element.val() === null ? "" : element.val();

                    if (element.hasClass("xsd_decimal"))
                        val = val.replace(',', '.');
                    else if (element.hasClass("xsd_date"))
                        val = xmlHelper.toXmlDate(val);
                    else if (element.hasClass("xsd_time"))
                        val = xmlHelper.toXmlTime(val);
                    else if (element.hasClass("xsd_dateTime"))
                        val = xmlHelper.toXmlDateTime(val);

                    xml += '<' + attr + '>' + HtmlEncode(val) + '</' + attr + '>';
                }
            }
        }

        if (acceptEmptyForm)
            element.children().each(processHtml);
        else {
            if (element.attr(isempty) === undefined || element.attr(isempty) == "false")
                element.children().each(processHtml);
        }

        if (element.hasClass(layoutRow)) {
            firstInput = element.children("input:first");
            if (firstInput.attr(name) != 'Attachments') {
                if (element.hasClass('hiddenSection')) {
                    xml += '</' + disableValidatorPrefix + firstInput.attr(name) + '>';
                } else {
                    xml += '</' + firstInput.attr(name) + '>';
                }
            }
        }
    }

    $('#main').children('div').each(processHtml);

    xml += '</' + formId + '>';

    return xml;
}

var xmlHelper = (function (helper) {
    var toDateRegex = /^([0-9]{1,2})\.([0-9]{1,2})\.([0-9]{1,4})$/g,
	    fromDateRegex = /^([0-9]{1,4})\-([0-9]{1,2})\-([0-9]{1,2})$/g,
        toTimeRegex = /^([0-9]{1,2})\:([0-9]{1,2})$/g,
        fromTimeRegex = /^([0-9]{1,2})\:([0-9]{1,2})\:([0-9]{1,2})$/g,
        toDateTimeRegex = /^([0-9]{1,2})\.([0-9]{1,2})\.([0-9]{1,4}) ([0-9]{1,2})\:([0-9]{1,2})$/g,
	    fromDateTimeRegex = /^([0-9]{1,4})\-([0-9]{1,2})\-([0-9]{1,2})T([0-9]{1,2})\:([0-9]{1,2})\:([0-9]{1,2})$/g;

    helper.toXmlDate = function (value) {
        if (value) {
            toDateRegex.lastIndex = 0;
            var matches = toDateRegex.exec($.trim(value));
            if (matches && matches.length === 4) {
                value = matches[3] + '-' + matches[2] + '-' + matches[1];
            }
        }

        return value || '';
    };

    helper.fromXmlDate = function (value) {
        if (value) {
            fromDateRegex.lastIndex = 0;
            var matches = fromDateRegex.exec($.trim(value));
            if (matches && matches.length === 4) {
                value = matches[3] + '.' + matches[2] + '.' + matches[1];
            }
        }

        return value || '';
    };

    helper.toXmlTime = function (value) {
        if (value) {
            toTimeRegex.lastIndex = 0;
            var matches = toTimeRegex.exec($.trim(value));
            if (matches && matches.length === 3) {
                value = matches[1] + ':' + matches[2] + ':00';
            }
        }

        return value || '';
    };

    helper.fromXmlTime = function (value) {
        if (value) {
            fromTimeRegex.lastIndex = 0;
            var matches = fromTimeRegex.exec($.trim(value));
            if (matches && matches.length === 4) {
                value = matches[1] + ':' + matches[2];
            }
        }

        return value || '';
    };

    helper.toXmlDateTime = function (value) {
        if (value) {
            toDateTimeRegex.lastIndex = 0;
            var matches = toDateTimeRegex.exec($.trim(value));
            if (matches && matches.length === 6) {
                value = matches[3] + '-' + matches[2] + '-' + matches[1] + 'T' + matches[4] + ':' + matches[5] + ':00';
            }
        }

        return value || '';
    };

    helper.fromXmlDateTime = function (value) {
        if (value) {
            fromDateTimeRegex.lastIndex = 0;
            var matches = fromDateTimeRegex.exec($.trim(value));
            if (matches && matches.length === 7) {
                value = matches[3] + '.' + matches[2] + '.' + matches[1] + ' ' + matches[4] + ':' + matches[5];
            }
        }

        return value || '';
    };

    helper.fromXmlAnyURI = function (value) {
        if (value) {
            value = value.replace(/mailto:/gi, "");
        }

        return value || '';
    };

    return helper;
}({}));

function GetMetadataNamespace() {
    var xmlns = '';
    var mtdNamespace = $('form').find("#mtd_namespace")[0];
    if (mtdNamespace != undefined) {
        mtdNamespace = mtdNamespace.innerHTML;
        if (mtdNamespace != undefined && mtdNamespace != xmlns) {
            xmlns = " xmlns='" + mtdNamespace + "'";
        }
    }
    return xmlns;
}

function GetValueWithoutIncremental(value) {
    var regEx = new RegExp(repeatingPostfix + "\\d+$");
    return value.replace(regEx, '');
}

function ShowData() {
    var xml = GetData();
    alert(decodeURIComponent(xml));
}

function ShowDataWithAttachments() {
    var xml = GetData();
    var formId = GetFormId();
    var xmlWithAttachments = xml.replace('</' + formId + '>', '');

    var attachmentsData = '';
    for (var key in attachmentsDataArray) {
        attachmentsData = attachmentsData + attachmentsDataArray[key];
    }

    xmlWithAttachments += '<Attachments>' + attachmentsData + '</Attachments>';
    xmlWithAttachments += '</' + formId + '>';

    var parentWindow = window.opener;
    parentWindow.setFinalXml(xmlWithAttachments);
}

function SaveXml() {
    localStorage.setItem(GetFormStorageKey(), GetData());
    var message = '';

    switch (GetFormLanguage()) {
        case 'en':
            message = "Form " + "'" + GetFormStorageKey().replace('ego_', '') + "'" + " has been successfully stored in the repository";
            break;

        default: // sk a default
            message = "Formular " + "'" + GetFormStorageKey().replace('ego_', '') + "'" + " bol uspesne ulozeny do lokalneho uloziska";
    }

    alert(message);

    ShowSavedForms();
}

function ShowSavedForms() {
    var savedForms = "<span class='fieldContent'>";
    var savedFormsCount = 0;

    for (var i = 0; i < localStorage.length; i++) {
        if (localStorage.key(i) == GetFormStorageKey()) {
            savedForms += "<span>" + localStorage.key(i).substr(4) + "</span><br/>";
            savedFormsCount++;
        }
    }
    savedForms += "</span>";

    $('#lcellSavedForms').html(savedForms);
    var element = $("#savedFormsContainer");
    if (savedFormsCount > 0) {
        element.show();
    }
    else {
        element.hide();
    }
}

function PrintForm() {
    window.print();
}

function GetFormId() {
    return $("form:has(#main)").attr("ID");
}

//////////////////// ML /////////////////////////

function IsError() {
    var errors = $('.error');

    for (i = 0; i < errors.length; i++) {
        if ($(errors[i]).is(':visible'))
            return true
    }

    return false;
}

////////////////////////////////////////////////

function ValidateForm() {
    //////////////////// ML /////////////////////////

    errorValidateFocusOut = false;

    if ($('#' + GetFormId()).valid()) {
        /*switch (GetFormLanguage()) {
            case 'en':
                alert("Check the form was successful.");
                break;

            default: // sk a default
                alert("Kontrola formulára prebehla úspešne.");
        }*/

        return true;
    }
    else if (IsError()) {
        /*switch (GetFormLanguage()) {
            case 'en':
                alert("The form contains the validation errors.");
                break;

            default: // sk a default
                alert("Formulár obsahuje validačné chyby.");
        }*/

        return false;
    }
    else {
        /*switch (GetFormLanguage()) {
            case 'en':
                alert("Formulár obsahuje logické chyby. Naozaj chcete pokračovať?");
                break;

            default: // sk a default
                alert("The form contains a logic error. Are you sure?");
        }*/

        return true;
    }

    ////////////////////////////////////////////////

    //return $('#' + GetFormId()).valid();
}

function CloseForm(fillerUri) {
    var xml = GetData();
    var parentWindow = window.opener;

    try {
        var formId = parentWindow.getFormId();
        var eDoc = TranslateNativeToEDoc(xml, fillerUri + "TranslateNativeToEDoc", formId);

        parentWindow.setXmlData(eDoc);

        window.close();
    } catch (err) {
        switch (GetFormLanguage()) {
            case 'en':
                alert('workdesk was closed');
                break;

            default: // sk a default
                alert('workdesk bol uzavretý');
        }
    }
}

function CancelForm() {
    window.close();
}

function SaveAndCloseForm(fillerUri) {
    var form = $('#' + GetFormId());
    var $validator = form.validate();
    var confirmText = '';

    switch (GetFormLanguage()) {
        case 'en':
            confirmText = "The form contains errors. Are you sure you want to save?";
            break;

        default: // sk a default
            confirmText = "Formulár obsahuje chyby. Naozaj ho chcete uložiť?";
    }

    ValidateForm(form);

    if ($validator.numberOfInvalids() > 0) {
        if (confirm(confirmText)) {
            CloseForm(fillerUri);
        } else {
        }
    }
    else {
        CloseForm(fillerUri);
    }
}

function GetAttachments() {
    var files = $('input[type="file"]')[0].files;
    var attachements = "";
    for (var i = 0; i < files.length; i++) {
        attachements += files[i].name + "<br/>";
    }

    return attachements;
}

function ClearForm(element) {
    $(element).find(':input').each(function () {
        switch (this.type) {
            case 'password':
            case 'select-multiple':
            case 'select-one':
            case 'text':
            case 'textarea':
                $(this).val('');
                break;
            case 'checkbox':
            case 'radio':
                this.checked = false;
        }
    });
}

function GetFormStorageKey() {
    var formId = GetFormId();
    return 'ego_' + formId;
}

function HandleFileSelect(evt) {
    var files = evt.target.files;

    for (var i = 0, f; f = files[i]; i++) {
        var reader = new FileReader();

        reader.onload = (function (theFile) {
            return function (e) {
                attachmentsDataArray[evt.target.id] = '<Attachment><Name>' + theFile.name + '</Name><Type>' + theFile.type
                    + '</Type><Size>' + theFile.size + '</Size>' + '<Content>' + e.target.result + '</Content></Attachment>';
            };
        })(files[0]);

        reader.readAsDataURL(files[0]);
    }
}

function WrapXmlData(xml) {
    return "<FormDataXml><XmlData>" + xml + "</XmlData></FormDataXml>";
}

function TranslateNativeToEDoc(xml, url, formId) {
    var formDataXml = WrapXmlData(xml);
    var formData = '{"FormId": "' + formId + '", "FormDataXml": "' + formDataXml + '"}';

    var contentType = "application/json";

    var eDoc = "";
    $.ajax({
        type: 'POST',
        url: url,
        data: formData,
        contentType: contentType,
        success: function (result) {
            eDoc = result;
        },
        error: function (result) {
            alert(result);
        },
        async: false
    });

    return eDoc.Content;
}

function ValidateFormWithXsd(fillerUri) {
    var xml = GetData();
    var parentWindow = window.opener;

    try {
        var formId = parentWindow.getFormId();
        var valRes = CallValidateFormWithXsd(xml, fillerUri + "ValidateFormWithXsd", formId);

        ShowValidationResult(valRes, "xsdValidation");

    } catch (err) {
        alert(err);
    }
}

function ValidateFormWithServer(fillerUri) {
    var xml = GetData();
    var parentWindow = window.opener;

    try {
        var formId = parentWindow.getFormId();
        var valRes = CallValidateFormWithServer(xml, fillerUri + "ValidateForm", formId);

        ShowValidationResult(valRes, "serverValidation");

    } catch (err) {
        alert(err);
    }
}

function ShowValidationResult(result, validationType) {
    var valid = true;
    var resultXML = $.parseXML(result),
    resultXMLTraversable = $(resultXML);
    var responseCode = resultXMLTraversable.find("response > code").text();
    var responseErrors = resultXMLTraversable.find("response > errors > error");
    var responseXsltErrors = resultXMLTraversable.find("response > errors > xsltError");
    var localErrors = new Array();
    var ok = "ok";
    validatorObject.resetForm();

    if (responseCode == ok && responseErrors.length == 0 && responseXsltErrors.length == 0) {
        validatorObject.resetForm();
        statusDialog.hideProgress();

        switch (GetFormLanguage()) {
            case 'en': {
                statusDialog.setMessage(validationType === "xsdValidation" ? "The form is valid against XSD schema." : "The form is valid.");
                statusDialog.setOptions({ "buttons": { "Ok": function () { statusDialog.hideDialog(); } } });
            }
                break;

            default: { // sk a default
                statusDialog.setMessage(validationType === "xsdValidation" ? "Formulár je validný voči XSD schéme." : "Formulár je validný.");
                statusDialog.setOptions({ "buttons": { "Ok": function () { statusDialog.hideDialog(); } } });
            }

        }

        statusDialog.showDialog();
    }

    var valMsg = new Object;
    responseErrors.each(function (index, item) {
        if (!AddValidationMessage(index, item, valMsg)) {
            localErrors.push($(item).text());
        }
    });

    if (responseCode != ok || responseErrors.length != 0) {
        valid = false;
        validatorObject.settings.onfocusout = false;
        validatorObject.showErrors(valMsg);
        validatorObject.focusInvalid();
    }

    if (responseCode != ok || responseXsltErrors.length != 0 || localErrors.length != 0) {
        valid = false;
        var xsltErrorDiv = $("#xsltErrorContainer");

        if (!xsltErrorDiv.length) {
            $('#errorsContainerDiv').after('<div id="xsltErrorContainer"></div>');
            xsltErrorDiv = $("#xsltErrorContainer");
        }
        else {
            xsltErrorDiv.empty();
        }

        responseXsltErrors.each(function (index, item) {
            var input = $(item);
            xsltErrorDiv.append('<li>' + input.text() + '</li>');
        });

        for (var i = 0; i < localErrors.length; i++) {
            xsltErrorDiv.append('<li>' + localErrors[i] + '</li>');
        }
    }
    else {
        var xsltErrorDiv = $('#xsltErrorContainer');
        if (xsltErrorDiv.length) {
            xsltErrorDiv.remove();
        }
    }
    return valid;
}

function CallValidateFormWithXsd(xml, url, formId) {
    var formDataXml = WrapXmlData(xml);
    var formData = '{"FormId": "' + formId + '", "FormDataXml": "' + formDataXml + '"}';

    var contentType = "application/json";

    var response = "";
    $.ajax({
        type: 'POST',
        url: url,
        data: formData,
        contentType: contentType,
        success: function (result) {
            response = result;
        },
        error: function (result) {
            alert(result);
        },
        async: false
    });

    return response.Details;
}

function CallValidateFormWithServer(xml, url, formId) {
    var formDataXml = WrapXmlData(xml);
    var formData = '{"FormId": "' + formId + '", "FormDataXml": "' + formDataXml + '"}';

    var contentType = "application/json";

    var response = "";
    $.ajax({
        type: 'POST',
        url: url,
        data: formData,
        contentType: contentType,
        success: function (result) {
            response = result;
        },
        error: function (result) {
            alert(result);
        },
        async: false
    });

    return response.Content;
}

function GetConfigurationValue(key, url, callbackName) {
    var parentWindow = window.opener;
    try {
        var formId = parentWindow.getFormId();
        var values = "ConfigurationKey=" + key + "&FormId=" + formId;
        var contentType = "application/json";

        $.ajax({
            url: url,
            dataType: "jsonp",
            contentType: contentType,
            data: values,
            jsonpCallback: callbackName,
            jsonp: 'callback'
        });
    } catch (err) {
        switch (GetFormLanguage()) {
            case 'en':
                alert('workdesk was closed');
                break;

            default: // sk a default
                alert('workdesk bol uzavretý');
        }
    }
}

function HtmlEncode(value) {
    if (value == null) {
        return value;
    }

    value = $('<div/>').text(value).html();
    value = value.replace(/&nbsp;/g, "&#160;");

    var coding = Array();

    coding['92'] = '#92';
    coding['10'] = '#10';
    coding['34'] = 'quot';
    var finalText = "";

    for (var i = 0; i < value.length ; i++) {
        var char = value.charCodeAt(i);
        var characters = value.charAt(i);

        for (var key in coding) {
            if (key == char) {
                characters = '&' + coding[char] + ';';
                break;
            }
        }

        finalText += characters;
    }

    return finalText;
}

function DisableForm() { $('form :input').attr('disabled', 'disabled'); }

function EnableForm() {
    $('form :input').each(function () {
        var input = $(this);
        if (input.attr('isReadonly') == undefined) {
            input.removeAttr('disabled');
        }
    });
}

function SaveXmlAs() {
    try {
        var xml = GetData();
        var fileName = GetFormId() + ".xml";
        this.SaveToFile(xml, 'text/xml', fileName);
    }
    catch (exc) {
        alert(exc);
    }
}

function SaveToFile(content, type, filename) {
    if (window.Blob === 'undefined' || !window.Blob) {
        switch (GetFormLanguage()) {
            case 'en':
                throw "Save this browser is not supported, use a newer browser version";

            default: // sk a default
                throw "Ukladanie v tomto prehliadači nie je podporované, použite novšiu verziu prehliadača";
        }
    }

    try {
        var blob = new Blob([content], { type: type });
        $.saveAs(blob, filename);
    }
    catch (exc) {
        switch (GetFormLanguage()) {
            case 'en':
                throw "Error saving the file to disk";

            default: // sk a default
                throw "Chyba pri ukladaní súboru na disk";
        }
    }
}

function LoadFromFile() {
    if (!window.FileReader) {
        switch (GetFormLanguage()) {
            case 'en':
                throw "This functionality is not supported in this browser, use a newer browser version"

            default: // sk a default
                throw "Táto funkcionalita nie je podporovaná v tomto prehliadači, použite novšiu verziu prehliadača"
        }
    }
    var content = $("#form-buttons-load-dialog");
    var exist = true;

    if (content.length == 0) {
        exist = false;
        var file = $('<input type="file" id="form-buttons-input-file"/>');
        var submit = '';

        switch (GetFormLanguage()) {
            case 'en': {
                submit = $('<input type="button" name="form-buttons-load-dialog-confirm" class="button ui-button ui-widget ui-state-default ui-corner-all ui-button-text-onl" value="Load file" id="form-buttons-load-dialog-confirm" disabled = "disabled" />');
                content = $('<div id="form-buttons-load-dialog" />').attr('title', "Select the xml file").append(file).append(submit);
            }
                break;

            default: { // sk a default
                submit = $('<input type="button" name="form-buttons-load-dialog-confirm" class="button ui-button ui-widget ui-state-default ui-corner-all ui-button-text-onl" value="Nahrať súbor" id="form-buttons-load-dialog-confirm" disabled = "disabled" />');
                content = $('<div id="form-buttons-load-dialog" />').attr('title', "Vyberte xml súbor").append(file).append(submit);
            }

        }

        submit.bind('click', function (e) {
            var dialog = $('#form-buttons-load-dialog');
            var input = $('input:file', dialog)[0];
            var currentFile = input.files[0];

            if (currentFile) {
                if (!currentFile.name.match(/^.*\.xml$/i)) {
                    switch (GetFormLanguage()) {
                        case 'en':
                            alert('Incorrect file format.');
                            break;

                        default: // sk a default
                            alert('Nesprávny formát súboru.');
                    }

                    return;
                }

                if (!currentFile.size > 15 * 1024 * 1024) {
                    switch (GetFormLanguage()) {
                        case 'en':
                            alert('The file must not be greater than 15MB.');
                            break;

                        default: // sk a default
                            alert('Súbor nesmie byť väčší ako 15MB.');
                    }

                    return;
                }
            }

            LoadXmlFromInput(currentFile);
        });

        file.bind('change', function (e) {
            if ($(e.target).val()) {
                $('#form-buttons-load-dialog-confirm').removeAttr('disabled');
            } else {
                $('#form-buttons-load-dialog-confirm').attr('disabled', 'disabled');
            }
        });

        $('#' + GetFormId()).append(content);
    }
    else {
        $("#form-buttons-input-file").val('');
    }

    content.dialog({
        autoOpen: false,
        modal: true,
        width: 500
    });

    if (!exist) {
        $('#form-buttons-load-dialog').closest(".ui-dialog").addClass("load-dialog");
    }

    content.dialog('open');
}

function LoadXmlFromInput(file) {
    var reader = new FileReader();
    var readerHelp = new FileReader();
    reader.onload = function (e) {
        try {
            var xmlDoc = $.parseXML(e.target.result);
            var indexes = Array();
            var nodeWithContains = new Array();
            var emptyNativeTemplate = GetEmptyNativeTemplate();
            var emptyNativeTemplateDoc = $.parseXML(emptyNativeTemplate);
            AddMissingElements(xmlDoc.childNodes[0], emptyNativeTemplateDoc.childNodes[0], nodeWithContains);
            LoadXml(xmlDoc.childNodes[0], indexes);

            switch (GetFormLanguage()) {
                case 'en':
                    alert('Filling the form was successful');
                    break;

                default: // sk a default
                    alert('Naplnenie formulára bolo úspešné');
            }
        }
        catch (exc) {
            switch (GetFormLanguage()) {
                case 'en':
                    alert('Filling the form has been unsuccessful');
                    break;

                default: // sk a default
                    alert('Naplnenie formulára bolo neúspešné');
            }
        }
    };

    reader.onerror = function () {
        switch (GetFormLanguage()) {
            case 'en':
                alert('Could not read file.');
                break;

            default: // sk a default
                alert('Nepodarilo sa prečítať súbor.');
        }
    };

    readerHelp.onload = function (e) {
        if (e.target.result.search("encoding=\"ISO-8859-2\"") > 0 || e.target.result.search("encoding=\"iso-8859-2\"") > 0 || e.target.result.search("encoding=\"Iso-8859-2\"") > 0) {
            reader.readAsText(file, 'ISO-8859-2');
        }
        else if (e.target.result.search("encoding=\"WINDOWS-1250\"") > 0 || e.target.result.search("encoding=\"Windows-1250\"") > 0 || e.target.result.search("encoding=\"windows-1250\"") > 0) {
            reader.readAsText(file, 'Windows-1250');
        }
        else {
            reader.readAsText(file);
        }
    };

    readerHelp.onerror = function () {
        switch (GetFormLanguage()) {
            case 'en':
                alert('Could not read file.');
                break;

            default: // sk a default
                alert('Nepodarilo sa prečítať súbor.');
        }
    };

    readerHelp.readAsText(file);
}

function GetFieldNode(node) {
    if (node == null) {
        return null;
    }

    if (node.childNodes.length > 0) {
        for (var k = 0; k < node.childNodes.length; k++) {
            if (node.childNodes[k].nodeName == "#text") {
                return node.childNodes[k];
            }
        }
    }

    return null;
}

function LoadXml(rootNode, indexes) {

    function IsEmpty(node) {
        if (node.nodeName == "#text") {
            if (node.nodeValue != null || node.nodeValue !== "") {
                return false;
            }
        }
        else {
            for (var i = 0; i < node.childNodes.length; i++) {
                var result = IsEmpty(node.childNodes[i]);
                if (!result) {
                    return result;
                }
            }
        }

        return true;
    }

    var lastNode = null;

    for (var i = 0; i < rootNode.childNodes.length; i++) {

        var node = rootNode.childNodes[i];

        var nodeName = node.nodeName;
        nodeName = nodeName.replace("DoNotValidate_", "");

        var fieldNode = GetFieldNode(node);
        var lastFieldNode = GetFieldNode(lastNode);

        if (indexes[nodeName] === undefined) {
            indexes[nodeName] = 0;
        }
        else {
            //ak su oba fieldnody a maju rovnaky name, tak sa nebude zvysovat, lebo sa bude jednat o multi prvok
            if (fieldNode == null || lastFieldNode == null || fieldNode.parentNode.nodeName != lastFieldNode.parentNode.nodeName) {
                indexes[nodeName]++;
            }
        }

        lastNode = node;

        if (fieldNode == null) {
            var allLayoutRows = $('div[id^=layoutRow]');
            var repeatingIndex = indexes[nodeName];
            var repeatingPostfixText = repeatingIndex;
            if (repeatingIndex == 0) {
                repeatingPostfixText = '';
            }
            else {
                repeatingPostfixText = repeatingPostfix + repeatingIndex;
            }

            var foundSection = null;
            var layoutRowID = null;

            allLayoutRows.each(function () {
                var layoutRow = $(this);
                if (layoutRow.find('[name=' + nodeName + ']').length > 0) {
                    var layoutRowPostfix = layoutRow.attr('id').replace(GetValueWithoutIncremental(layoutRow.attr('id')), "");
                    layoutRowID = layoutRow.attr('id');
                    if (layoutRowPostfix == repeatingPostfixText) {
                        foundSection = layoutRow;
                    }
                }
            });

            if ((foundSection == null || (foundSection.attr("isempty") == "true") && !IsEmpty(node)) && layoutRowID != null) {
                var layoutRowIDWithoutIncremental = GetValueWithoutIncremental(layoutRowID);
                var addButton = $('div[id^=' + layoutRowID + ']').last().find('#addSection' + layoutRowIDWithoutIncremental);
                if (addButton[0] != null) {
                    addButton.click();
                }
            }

            LoadXml(node, indexes);
        }
        else {
            node = fieldNode;
            var repeatingIndex = indexes[nodeName];
            var repeatingPostfixText = repeatingIndex;
            if (repeatingIndex == 0) {
                repeatingPostfixText = '';
            }
            else {
                repeatingPostfixText = repeatingElementPostfix + repeatingIndex;
            }

            var field = $("[name=" + nodeName + repeatingPostfixText + "]");

            if (field.length > 0) {
                if (field.is(':checkbox')) {
                    if (field.hasClass("checkBox")) {
                        if (field.hasClass("xsd_boolean")) {
                            if (node.nodeValue == "1") {
                                var fieldCheckbox = $(field);
                                if (fieldCheckbox.attr("disabled") !== undefined || fieldCheckbox.attr("readonly") !== undefined) {
                                    fieldCheckbox.attr("checked", "true");
                                }
                                field.click();
                            }
                        }
                        else {
                            if (field.val() == node.nodeValue) {
                                var fieldCheckbox = $(field);
                                if (fieldCheckbox.attr("disabled") !== undefined || fieldCheckbox.attr("readonly") !== undefined) {
                                    fieldCheckbox.attr("checked", "true");
                                }
                                field.click();
                            }
                        }
                    }
                    else {
                        for (var index = 0; index < field.length; index++) {
                            var childNode = field[index];
                            if (childNode.value == node.nodeValue) {
                                var fieldCheckbox = $(childNode);
                                if (fieldCheckbox.attr("disabled") !== undefined || fieldCheckbox.attr("readonly") !== undefined) {
                                    fieldCheckbox.attr("checked", "true");
                                }
                                childNode.click();
                                break;
                            }
                        }
                    }

                }
                else if (field.is(':radio')) {
                    for (var index = 0; index < field.length; index++) {
                        var childNode = field[index];
                        if (childNode.value == node.nodeValue) {
                            var radio = $(childNode);
                            if (radio.attr("disabled") !== undefined || radio.attr("readonly") !== undefined) {
                                radio.attr("checked", "true");
                            }

                            childNode.click();
                            break;
                        }
                    }
                }
                else if (field.attr("multiple")) {
                    for (var index = 0; index < field[0].childNodes.length; index++) {
                        var childNode = field[0].childNodes[index];
                        if (childNode.value == node.nodeValue) {
                            childNode.selected = true;
                            break;
                        }
                    }
                } else {
                    val = node.nodeValue;
                    if (val != "") {
                        if (field.hasClass("xsd_decimal"))
                            val = val.replace('.', ',');
                        else if (field.hasClass("xsd_date"))
                            val = xmlHelper.fromXmlDate(val);
                        else if (field.hasClass("xsd_time"))
                            val = xmlHelper.fromXmlTime(val);
                        else if (field.hasClass("xsd_dateTime"))
                            val = xmlHelper.fromXmlDateTime(val);
                        else if (field.hasClass("xsd_anyURI"))
                            val = xmlHelper.fromXmlAnyURI(val);
                    }

                    field.val(val);
                }
            }
        }
    }
}

// Funkcie pre prekrytie ukladania a nacitavania
function GetXpath(elements) {
    var xpath = "";
    for (var i = 0; i < elements.length; i++) {
        xpath += "/" + elements[i].nodeName;

        if (elements[i].parentNode != null && elements[i].attributes != null) {
            //rootu sa preskakuju namespaces
            if (elements[i].attributes.length == 0 || i == 0) {
                continue;
            }

            xpath += "[";

            for (var j = 0; j < elements[i].attributes.length; j++) {
                xpath += "@" + elements[i].attributes[j].nodeName + "='" + elements[i].attributes[j].value + "'";
                if (j != elements[i].attributes.length - 1) {
                    xpath += " and ";
                }
            }

            xpath += "]";
        }
    }

    return xpath;
}

//vrati list nodov , ktory urcuje jeho absolutnu cestu az do rootu
function AncestorsAndSelf(element) {
    var parts = new Array();
    var actual = element;

    while (actual != null && actual.parentNode != null) {
        parts.push(actual);
        actual = actual.parentNode;
    }

    return parts.reverse();
}

//najde nod v zadanom roote na zaklade xpathu
function FoundNode(root, xPath) {

    var ancestorsAndSelfParent = AncestorsAndSelf(root);
    var xPathParent = GetXpath(ancestorsAndSelfParent);
    if (xPath == xPathParent) {
        return root;
    }

    for (var i = 0; i < root.childNodes.length; i++) {
        var foundNode = FoundNode(root.childNodes[i], xPath);
        if (foundNode != null) {
            return foundNode;
        }
    }

    return null;
}

//najde nod v zadanom roote na zaklade nazvu
function FoundNodeByName(root, name) {

    if (root.nodeName == name) {
        return root;
    }

    for (var i = 0; i < root.childNodes.length; i++) {
        var foundNode = FoundNodeByName(root.childNodes[i], name);
        if (foundNode != null) {
            return foundNode;
        }
    }

    return null;
}

//na zaklade xpathov dodrzi sibblings
function SortXmlByXPath(root) {
    var sibblings = Array();

    if (root.nodeName == "#text") {
        return;
    }

    for (var i = 0; i < root.childNodes.length; i++) {
        var ancestorAndSibblings = AncestorsAndSelf(root.childNodes[i]);
        var xPath = GetXpath(ancestorAndSibblings);

        //pozaznamenava si pozicie
        if (sibblings[xPath] == undefined) {
            sibblings[xPath] = new Array();
        }

        sibblings[xPath].push(i);
    }

    var newList = new Array();

    //na zaklade pozicii vysklada nove poradie elementov
    for (var sibbling in sibblings) {
        for (var i = 0; i < sibblings[sibbling].length; i++) {
            var pom = sibblings[sibbling];
            newList.push(root.childNodes[pom[i]]);
        }
    }

    //zmazanie aktualnych nodov
    while (root.childNodes.length > 0) {
        root.removeChild(root.childNodes[0]);
    }

    for (var i = 0; i < newList.length; i++) {
        root.appendChild(newList[i]);
    }

    for (var i = 0; i < root.childNodes.length; i++) {
        SortXmlByXPath(root.childNodes[i]);
    }
}

//na zaklade xpathov vytvara vysledne xml
function BuildXmlFromXpaths(xPath, root, document) {
    if (xPath == "") {
        return;
    }

    var xPathParts = xPath.split('/');
    if (xPathParts.length == 0) {
        return;
    }

    var xPathElementName = xPathParts[0];
    var foundNode = FoundNodeByName(root, xPathElementName);

    if (foundNode == null) {
        var element = document.createElement(xPathElementName);
        root.appendChild(element);
        root = element;
    } else {
        root = foundNode;
    }

    var newXPath = "";
    for (var j = 1; j < xPathParts.length; j++) {
        newXPath += xPathParts[j] + "/";
    }

    if (newXPath.length > 0) {
        newXPath = newXPath.substring(0, newXPath.length - 1);
    }

    BuildXmlFromXpaths(newXPath, root, document);
}

//prejde cez vsetky elementy a vrati xml ako string
function ElementToString(root) {
    var xml = "";
    for (var i = 0; i < root.childNodes.length; i++) {
        var attributes = "";

        for (var j = 0; j < root.childNodes[i].attributes.length; j++) {
            attributes += " " + root.childNodes[i].attributes[j].name + "=\"" + root.childNodes[i].attributes[j].value + "\"";
        }

        xml += "<" + root.childNodes[i].nodeName + attributes + ">";
        if (root.childNodes[i].childNodes.length == 1 && root.childNodes[i].childNodes[0].nodeName == "#text") {
            xml += root.childNodes[i].childNodes[0].nodeValue;
        } else {
            xml += ElementToString(root.childNodes[i]);
        }
        xml += "</" + root.childNodes[i].nodeName + ">";
    }

    return xml;
}

//zmaze vsetky vyplnene hodnoty
function EmptyXmlNodeRecursive(node) {
    if (node.nodeName == "#text") {
        node.nodeValue = "";
    } else {
        for (var i = 0; i < node.childNodes.length; i++) {
            EmptyXmlNodeRecursive(node.childNodes[i]);
        }
    }
}

//zmaze elementy, ktore nie su namapovane
function RemoveElementsByNameNotInMapping(node, mapping) {
    if (node.nodeName == "#text") {
        return;
    }

    var found = false;
    var actualNode = node;

    for (var map in mapping) {
        if (node.nodeName == map) {
            found = true;
        }
    }

    if (!found) {
        actualNode = node.parentNode;
        for (var i = 0; i < node.childNodes.length; i++) {
            actualNode.appendChild(node.childNodes[i]);
        }

        if (actualNode == null) {
            return;
        }

        actualNode.removeChild(node);
    }

    for (var i = 0; i < actualNode.childNodes.length; i++) {
        RemoveElementsByNameNotInMapping(actualNode.childNodes[i], mapping);
    }
}

//prelozi z nativu do business
function TranslateNativeToEdoc(nativeXml, skXmlTemplate, mapping, translateType) {

    function TranslateRecursive(xmlDocNode, skXmlDocNode, template, translateType) {
        var sibblings = Array();

        for (var i = 0; i < xmlDocNode.childNodes.length; i++) {
            var xmlNode = xmlDocNode.childNodes[i];

            if (xmlNode.nodeName == "#text") {
                if (xmlNode.nodeValue != null) {
                    var parentXmlNode = xmlNode.parentNode;
                    var xPathEdoc = mapping[parentXmlNode.nodeName];

                    if (xPathEdoc !== undefined) {
                        var foundNode = FoundNode(skXmlDocNode, xPathEdoc);
                        if (foundNode != null) {
                            if (foundNode.childNodes.length == 0) {
                                foundNode.appendChild(xmlNode.cloneNode());
                            } else {
                                foundNode.childNodes[0].nodeValue = xmlNode.nodeValue;
                            }
                        }
                    }
                }

                continue;
            }

            if (sibblings[xmlNode.nodeName] == undefined) {
                sibblings[xmlNode.nodeName] = 0;
            }

            sibblings[xmlNode.nodeName]++;

            //opakoavacia sekacia
            if (sibblings[xmlNode.nodeName] > 1) {
                //kedze opakovacie nody maju rovnaky nazov ako v natove, staci len podla nazvu
                var repetitionNode = null;
                var repetitionNodeTemplate = null;

                if (translateType == "Dictionary") {
                    repetitionNode = FoundNodeByName(skXmlDocNode, xmlNode.nodeName);
                    repetitionNodeTemplate = FoundNodeByName(template, xmlNode.nodeName);
                }
                if (translateType == "Mapper") {
                    var xPathEdoc = mapping[xmlNode.nodeName];
                    repetitionNode = FoundNode(skXmlDocNode, xPathEdoc);
                    repetitionNodeTemplate = FoundNode(template, xPathEdoc);
                }

                if (repetitionNodeTemplate != null && repetitionNode != null) {
                    var clonedNode = repetitionNodeTemplate.cloneNode(true);
                    repetitionNode.parentNode.appendChild(clonedNode);
                    TranslateRecursive(xmlNode, clonedNode, template, translateType);

                    continue;
                }
            }

            TranslateRecursive(xmlNode, skXmlDocNode, template, translateType);
        }
    }

    var nativeDoc = $.parseXML(nativeXml);
    var eDocDoc = $.parseXML(skXmlTemplate);
    var template = $.parseXML(skXmlTemplate);
    TranslateRecursive(nativeDoc.childNodes[0], eDocDoc.childNodes[0], template, translateType);
    SortXmlByXPath(eDocDoc.childNodes[0]);

    return ElementToString(eDocDoc);
}

//prelozi z edoc do nativu
function TranslateEdocToNative(edocXml, nativeXmlTemplate, mapping, translateType) {

    function TranslateRecursive(edocDocNode, nativeXmlDocNode, template, translateType) {
        var sibblings = Array();

        for (var i = 0; i < edocDocNode.childNodes.length; i++) {
            var xmlNode = edocDocNode.childNodes[i];
            var ancesorsAndSelf = AncestorsAndSelf(xmlNode);
            var eDocXpath = GetXpath(ancesorsAndSelf);

            if (xmlNode.nodeName == "#text") {
                eDocXpath = eDocXpath.substring(0, eDocXpath.length - 6); // orezem este /#text zname
                if (xmlNode.nodeValue != null) {
                    //edoc 
                    var nativeName = null;
                    for (var map in mapping) {
                        if (mapping[map] == eDocXpath) {
                            nativeName = map;
                            var repetitionNodeTemplate = FoundNodeByName(template, nativeName);
                            //mozu byt rovnake xpathy, ale zaujimavy je len ten field
                            if (repetitionNodeTemplate.childNodes.length == 0 || repetitionNodeTemplate.childNodes[0].nodeName == "#text") {
                                break;
                            }
                        }
                    }

                    if (nativeName != null) {
                        var foundNode = FoundNodeByName(nativeXmlDocNode, nativeName);
                        if (foundNode != null) {
                            if (foundNode.childNodes.length == 0) {
                                foundNode.appendChild(xmlNode.cloneNode());
                            } else {
                                foundNode.childNodes[0].nodeValue = xmlNode.nodeValue;
                            }
                        }
                    }
                }

                continue;
            }

            if (sibblings[eDocXpath] == undefined) {
                sibblings[eDocXpath] = 0;
            }

            sibblings[eDocXpath]++;

            //opakoavacia sekacia
            if (sibblings[eDocXpath] > 1) {
                var repetitionNode = null;
                var repetitionNodeTemplate = null;

                if (translateType == "Dictionary") {
                    //kedze opakovacie nody maju rovnaky nazov ako v natove, staci len podla nazvu
                    repetitionNode = FoundNodeByName(nativeXmlDocNode, xmlNode.nodeName);
                    repetitionNodeTemplate = FoundNodeByName(template, xmlNode.nodeName);
                }
                if (translateType == "Mapper") {
                    var ancesorsAndSelf = AncestorsAndSelf(xmlNode);
                    var eDocXpath = GetXpath(ancesorsAndSelf);

                    //edoc 
                    var nativeName = null;
                    for (var map in mapping) {
                        if (mapping[map] == eDocXpath) {
                            nativeName = map;
                            repetitionNodeTemplate = FoundNodeByName(template, nativeName);
                            //mozu byt rovnake xpathy, ale zaujimavy je len ten pre sekciu
                            if (repetitionNodeTemplate.childNodes.length > 0 && repetitionNodeTemplate.childNodes[0].nodeName != "#text") {
                                break;
                            }
                        }
                    }

                    repetitionNode = FoundNodeByName(nativeXmlDocNode, nativeName);
                }

                if (repetitionNodeTemplate != null && repetitionNode != null) {
                    var clonedNode = repetitionNodeTemplate.cloneNode(true);
                    repetitionNode.parentNode.appendChild(clonedNode);
                    TranslateRecursive(xmlNode, clonedNode, template, translateType);

                    continue;
                }
            }

            TranslateRecursive(xmlNode, nativeXmlDocNode, template, translateType);
        }
    }

    var edocDoc = $.parseXML(edocXml);
    var nativeDoc = $.parseXML(nativeXmlTemplate);
    var template = $.parseXML(nativeXmlTemplate);
    TranslateRecursive(edocDoc.childNodes[0], nativeDoc.childNodes[0], template, translateType);
    SortXmlByXPath(nativeDoc.childNodes[0]);

    return ElementToString(nativeDoc);
}

//prebrane z 2.0
function AddMissingElements(sourceRootNode, destinationRootNode, nodeWithContains) {

    //zisti, ktore casti stromu maju contains
    function GetContainsInformation(node, nodeWithContains) {
        if (node.nodeName != "#text") {
            for (var k = 0; k < nodeWithContains.length; k++) {
                if (nodeWithContains[k].node == node) {
                    return { containsValue: nodeWithContains[k].containsValue, containsElementXpath: nodeWithContains[k].containsElementXpath };
                }
            }

            for (var i = 0; i < node.childNodes.length; i++) {
                var pom = GetContainsInformation(node.childNodes[i], nodeWithContains);
                if (pom != null) {
                    return pom;
                }
            }
        }

        return null;
    }

    function GetMultipleElements(destinationRootNode) {
        var multipleNames = new Array();

        //najdem viac nasbne vyskyty na danej urovni
        for (var i = 0; i < destinationRootNode.childNodes.length; i++) {
            var ancestorsAndSelf = AncestorsAndSelf(destinationRootNode.childNodes[i]);
            var xPathSource = GetXpath(ancestorsAndSelf);

            if (multipleNames[xPathSource] == undefined) {
                multipleNames[xPathSource] = new Array();
            }

            multipleNames[xPathSource].push(destinationRootNode.childNodes[i]);
        }

        //vyberiem len tie, ktore sa viac krat opakuju
        var multiple = new Array();
        for (var multipleName in multipleNames) {
            if (multipleNames[multipleName].length > 1) {
                for (var k = 0; k < multipleNames[multipleName].length; k++) {
                    multiple.push(multipleNames[multipleName][k]);
                }
            }
        }

        return multiple;
    }

    //zisti, contains elementy
    function GetElementWithContains(destinationRootNode, nodeWithContains) {

        var multiple = GetMultipleElements(destinationRootNode);
        var elementWithContains = new Array();

        //najde s contains a vlozi ich
        for (var i = 0; i < multiple.length; i++) {
            var containsInformation = GetContainsInformation(multiple[i], nodeWithContains);
            if (containsInformation != null) {
                elementWithContains.push({ node: multiple[i], containsValue: containsInformation.containsValue, containsElementXpath: containsInformation.containsElementXpath });
            }
        }

        return elementWithContains;
    }

    function FindAllNodes(childrenNodes, xpath, containsValue, templateContainsXPath) {
        var foundNodes = new Array();

        for (var j = 0; j < childrenNodes.length; j++) {
            if (childrenNodes[j].nodeName == "#text") {
                continue;
            }

            var ancestorsAndSelf = AncestorsAndSelf(childrenNodes[j]);
            var xPathSource = GetXpath(ancestorsAndSelf);

            if (xpath == xPathSource) {
                //ak je predchadzajuci destination to iste, tak nesmie vlozit ale bude sa klonovat
                if (containsValue != null) {
                    var foundElement = FindNode(childrenNodes[j], templateContainsXPath);
                    if (foundElement == null) {
                        continue;
                    }

                    var fieldNode = GetFieldNode(foundElement);

                    if (fieldNode == null || fieldNode.nodeValue.indexOf(containsValue) == -1) {
                        continue;
                    }
                }

                foundNodes.push(childrenNodes[j]);
            }
        }

        return foundNodes;
    }

    var finalArray = new Array();
    var finalExistingDestination = new Array();

    var elementWithConstains = GetElementWithContains(destinationRootNode, nodeWithContains);
    var multipleElements = GetMultipleElements(destinationRootNode);

    var actualChildrenNodes = new Array();

    for (var i = 0; i < sourceRootNode.childNodes.length; i++) {
        actualChildrenNodes.push(sourceRootNode.childNodes[i]);
    }

    var indexis = new Array();

    for (var i = 0; i < destinationRootNode.childNodes.length; i++) {
        if (destinationRootNode.childNodes[i].nodeName == "#text") {
            continue;
        }

        var isMultiple = false;
        for (var h = 0; h < multipleElements.length; h++) {
            if (multipleElements[h] == destinationRootNode.childNodes[i]) {
                isMultiple = true;

                break;
            }
        }

        var ancestorsAndSelfDestination = AncestorsAndSelf(destinationRootNode.childNodes[i]);
        var xPathDestination = GetXpath(ancestorsAndSelfDestination);

        if (indexis[xPathDestination] == undefined) {
            indexis[xPathDestination] = 0;
        }

        indexis[xPathDestination]++;

        var templateContainsValue = null;
        var templateContainsXPath = null;

        //ak je templatovy element oznaceny, ze bude mat aj contains
        for (var k = 0; k < elementWithConstains.length; k++) {
            if (elementWithConstains[k].node == destinationRootNode.childNodes[i]) {
                templateContainsValue = elementWithConstains[k].containsValue;

                //ak je len na konci xpathu
                var xpathInContainsConditions = elementWithConstains[k].containsElementXpath;
                var connector = "/";
                if (xpathInContainsConditions == '.') {
                    xpathInContainsConditions = "";
                    connector = "";
                }

                templateContainsXPath = xPathDestination + connector + xpathInContainsConditions;

                break;
            }
        }

        //najde vsetky elementy, ktore prisluchaju template
        var foundBusiness = FindAllNodes(actualChildrenNodes, xPathDestination, templateContainsValue, templateContainsXPath);

        //ak sa jedna o variantu, ze je element odliseny pomocou konstanty, nie contains, tak sa zoberie podla indexu
        if (isMultiple && templateContainsXPath == null) {
            if (indexis[xPathDestination] <= foundBusiness.length) {
                var tempFoundBusiness = new Array();
                tempFoundBusiness.push(foundBusiness[indexis[xPathDestination] - 1]);
                foundBusiness = tempFoundBusiness;
            }
        }

        var usedNodes = new Array();

        //zisti, ktore nody sa pouzili
        for (var h = 0; h < foundBusiness.length; h++) {
            for (var k = 0; k < actualChildrenNodes.length; k++) {
                if (foundBusiness[h] == actualChildrenNodes[k]) {
                    usedNodes.push(actualChildrenNodes[k]);
                }
            }
        }

        //zmaze nody, ktore uz boli pouzite
        if (usedNodes.length > 0) {
            var clonedActualChildrenNodes = actualChildrenNodes;
            actualChildrenNodes = new Array();
            for (var l = 0; l < clonedActualChildrenNodes.length; l++) {
                var found = false;

                for (var m = 0; m < usedNodes.length; m++) {
                    if (usedNodes[m] == clonedActualChildrenNodes[l]) {
                        found = true;
                        break;
                    }
                }

                if (!found) {
                    actualChildrenNodes.push(clonedActualChildrenNodes[l]);
                }
            }
        }

        if (foundBusiness.length > 0) {
            for (var k = 0; k < foundBusiness.length; k++) {
                finalArray.push(foundBusiness[k]);
                finalExistingDestination.push(destinationRootNode.childNodes[i]);
            }
        } else {
            finalArray.push(destinationRootNode.childNodes[i].cloneNode(true));
            finalExistingDestination.push(destinationRootNode.childNodes[i]);
        }
    }

    //este treba do final array poslat aj ostatne neprejdene elementy
    if (finalArray.length == 0) {
        return;
    }

    //zmaz cele pole
    while (sourceRootNode.childNodes.length > 0) {
        sourceRootNode.removeChild(sourceRootNode.childNodes[0]);
    }

    //nahraj childy nanovo
    for (var i = 0; i < finalArray.length; i++) {
        sourceRootNode.appendChild(finalArray[i]);
    }

    for (var i = 0; i < finalArray.length; i++) {
        AddMissingElements(finalArray[i], finalExistingDestination[i], nodeWithContains);
    }
}

function GetEmptyNativeTemplate() {

    var formId = GetFormId();
    var xmlns = GetMetadataNamespace();
    var xml = '<' + formId + xmlns + '>';
    var usedXmlNames = new Array();

    function processHtml() {
        var element = $(this);
        var name = 'name';
        var layoutRow = 'layoutRow';
        var firstInput;
        if (element.hasClass(layoutRow)) {
            firstInput = element.children("input:first");
            if (firstInput.attr(name) != 'Attachments') {
                xml += '<' + firstInput.attr(name) + '>';
            }
        }

        if (element.is(':input')) {
            if (element.is(':file') || element.is(':button') || element.attr('LookupDetailInfo') == "true")
                return;

            if (element.parent().hasClass(layoutRow))
                return;

            var attr = element.attr(name);
            if (attr != undefined) {
                var index = attr.indexOf(sign);
                if (index == -1) {
                    if (usedXmlNames[attr] == undefined) {
                        attr = attr.replace(disableValidatorPrefix, "");
                        xml += '<' + attr + '>' + '</' + attr + '>';
                        usedXmlNames[attr] = "";
                    }
                }
            }
        }

        element.children().each(processHtml);

        if (element.hasClass(layoutRow)) {
            firstInput = element.children("input:first");
            if (firstInput.attr(name) != 'Attachments') {
                xml += '</' + firstInput.attr(name) + '>';
            }
        }
    }

    $('#main').children('div').each(processHtml);

    xml += '</' + formId + '>';

    return xml;
}

function FillLookup(element, lookupDetailInfo, lookupFieldValue) {
    var lookupItems = null;
    var lookupUri = GetLookupUri();

    $.ajax({
        type: "GET",
        url: GetLookupUri(),
        async: false
    }).done(function (data) {
        if (data != null) {
            lookupItems = $.parseJSON(data.replace("(", "").replace(");", ""));
        }
    });

    if (lookupItems != null && lookupItems.aaData != null) {
        var randIndex = Math.floor(Math.random() * lookupItems.aaData.length);
        var randLookupItem = lookupItems.aaData[randIndex];

        element.val(randLookupItem[1]);
        lookupDetailInfo.val(randLookupItem[1]);
        lookupFieldValue.val(randLookupItem[0]);
    }
}

function FillSpecificInput(element, rules, data) {
    var rule;
    var finalValue = "";
    var rIndex = Math.floor((Math.random() * data.length));

    for (rule in rules) {
        if (rules.hasOwnProperty(rule)) {
            if (rule == "date") {
                var dateValue = new Date();
                finalValue = $.datepicker.formatDate('dd.mm.yy', new Date());
                break;
            }
            if (rule.indexOf("RegEx") != -1) {
                finalValue = "";
                if (element.attr("id").toLowerCase().indexOf("email") != -1
                  || element.siblings("span.XPathClass").html().indexOf("InternetAddress[contains(Address,'@')]/Address") != -1) {
                    finalValue = data[rIndex] + "@" + data[rIndex] + ".com";
                    break;
                } else
                    if (element.attr("title").toLowerCase().indexOf("webovú adresu") != -1
                      || element.siblings("span.XPathClass").html().indexOf("InternetAddress[not(contains(Address,'@'))]/Address") != -1) {
                        finalValue = data[rIndex] + ".com";
                        break;
                    } else
                        if (element.attr("title").toLowerCase().indexOf("číslo telefónu") != -1
                          || element.siblings("span.XPathClass").html().indexOf("TelephoneAddress/Number/FormattedNumber") != -1) {
                            finalValue = "+421";
                            for (var i = 0; i <= 8; i++) {
                                var randNumber = Math.floor((Math.random() * 10));
                                finalValue += randNumber;
                            }
                            break;
                        } else
                            if (element.attr("title").toLowerCase().indexOf("ičo") != -1) {
                                for (var i = 0; i <= 7; i++) {
                                    var randNumber = Math.floor((Math.random() * 10));
                                    finalValue += randNumber;
                                }
                                break;
                            } else
                                if (element.attr("title").toLowerCase().indexOf("dič") != -1
                                   || element.attr("title").toLowerCase().indexOf("rodné číslo") != -1) {
                                    for (var i = 0; i <= 9; i++) {
                                        var randNumber = Math.floor((Math.random() * 10));
                                        finalValue += randNumber;
                                    }
                                    break;
                                } else
                                    if (element.attr("title").toLowerCase().indexOf("poštové smerovacie číslo") != -1
                                      || element.siblings("span.XPathClass").html().indexOf("DeliveryAddress/PostalCode") != -1) {
                                        for (var i = 0; i <= 4; i++) {
                                            var randNumber = Math.floor((Math.random() * 10));
                                            finalValue += randNumber;
                                        }
                                        break;
                                    } else
                                        if (element.attr("title").toLowerCase().indexOf("ič dph") != -1) {
                                            finalValue = "SK";
                                            for (var i = 0; i <= 9; i++) {
                                                var randNumber = Math.floor((Math.random() * 10));
                                                finalValue += randNumber;
                                            }
                                            break;
                                        } else
                                            if (element.hasClass("xsd_decimal")) {
                                                var randNumber = Math.floor((Math.random() * 100) + 1);
                                                finalValue += randNumber;
                                            } else {
                                                //finalValue = "regex"; 
                                            }
                break;
            }
            if (rule == "minlength") {
                var randomValue = data[rIndex];
                var minLength = parseInt(rules.minlength);

                while (randomValue.length < minLength) {
                    randomValue += Math.floor((Math.random() * 10));
                }
                finalValue = randomValue;
            }
            if (rule == "maxlength") {
                var randomValue = data[rIndex];
                var maxLength = parseInt(rules.maxlength);

                if (randomValue.length <= maxLength) {
                    finalValue = randomValue;
                } else {
                    finalValue = randomValue.substring(0, maxLength);
                }
            }
            if (element.attr("title").toLowerCase().indexOf("poštové smerovacie číslo") != -1
              || element.siblings("span.XPathClass").html().indexOf("DeliveryAddress/PostalCode") != -1) {
                finalValue = "";
                for (var i = 0; i <= 4; i++) {
                    var randNumber = Math.floor((Math.random() * 10));
                    finalValue += randNumber;
                }
            }
        }
    }

    element.val(finalValue).change();
}

function FillForm() {
    // random click tlačidla Pridať         

    var elements = $("input:radio, input:checkbox, select, input:text, textarea");
    var data = ["lorem", "ipsum", "dolor", "sit", "amet", "consectetur", "adipiscing", "elit", "ut", "aliquam", "purus", "sit", "amet", "luctus", "venenatis", "lectus", "magna", "fringilla", "urna", "porttitor", "rhoncus", "dolor", "purus", "non", "enim", "praesent", "elementum", "facilisis", "leo", "vel", "fringilla", "est", "ullamcorper", "eget", "nulla", "facilisi", "etiam", "dignissim", "diam", "quis", "enim", "lobortis", "scelerisque", "fermentum", "dui", "faucibus", "in", "ornare", "quam", "viverra", "orci", "sagittis", "eu", "volutpat", "odio", "facilisis", "mauris", "sit", "amet", "massa", "vitae", "tortor", "condimentum", "lacinia", "quis", "vel", "eros", "donec", "ac", "odio", "tempor", "orci", "dapibus", "ultrices", "in", "iaculis", "nunc", "sed", "augue", "lacus", "viverra", "vitae", "congue", "eu", "consequat", "ac", "felis", "donec", "et", "odio", "pellentesque", "diam", "volutpat", "commodo", "sed", "egestas", "egestas", "fringilla", "phasellus", "faucibus", "scelerisque", "eleifend", "donec", "pretium", "vulputate", "sapien", "nec", "sagittis", "aliquam", "malesuada", "bibendum", "arcu", "vitae", "elementum"];
    var dataLength = data.length;

    elements.each(function () {
        var element = $(this);
        if (element.is(":visible") && !element.is(":disabled") && element.attr("readonly") != "readonly") {
            switch (this.type) {
                case 'radio': {
                    var elemName = element.attr("name");
                    var allRb = $("[name='" + elemName + "']");
                    if (!allRb.is(":checked")) {
                        var randIndex = Math.floor(Math.random() * allRb.length);
                        allRb.eq(randIndex).click();
                    }
                }
                    break;
                case 'checkbox': {
                    var randCheck = Math.floor(Math.random() * 2);
                    if (element.hasClass("xsd_required")) {
                        randCheck = 1;
                    }
                    if (randCheck && !element.is(":checked")) {
                        element.click();
                    }
                }
                    break;
                case 'select-one': {
                    if (element.is(":blank")) {
                        var options = element.find("option");
                        var randIndex = Math.floor((Math.random() * (options.length - 1)) + 1);
                        var selectedOption = options.eq(randIndex).val();
                        element.val(selectedOption).change();
                    }
                }
                    break;
                case 'text': {
                    if (element.is(":blank")) {
                        if (element.hasClass("remoteLookup")) {
                            var lookupDetailInfo = element.siblings(".LookupDetailInfo");
                            var fieldValueId = element.attr("id") + "ItemName";
                            var lookupFieldValue = $("[id='" + fieldValueId + "']");

                            FillLookup(element, lookupDetailInfo, lookupFieldValue);
                        } else {
                            FillSpecificInput(element, element.rules(), data);
                        }
                    }
                }
                    break;
                case 'textarea': {
                    if (element.is(":blank")) {
                        var randLength = Math.floor((Math.random() * dataLength - 1) + 1);
                        var genString = "";

                        for (var i = 0; i <= randLength; i++) {
                            var randIndex = Math.floor((Math.random() * dataLength - 1));
                            if (i == 0) {
                                genString = data[randIndex];
                            } else {
                                genString += " " + data[randIndex];
                            }
                        }

                        element.val(genString).change();
                    }
                }
                    break;
                default:
                    break;
            }
        }
    });
}