<?xml version="1.0" encoding="utf-8"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:fo="http://www.w3.org/1999/XSL/Format" xmlns:d="http://docbook.org/ns/docbook" xmlns:xi="http://www.w3.org/2001/XInclude" xmlns:exsl="http://exslt.org/common" xmlns:egonp="http://schemas.gov.sk/form/50349287.DolozkaPravoplatnostiAVykonatelnosti.sk/1.0" xml:lang="en" exclude-result-prefixes="d" version="1.0">
  <xsl:template match="/">
    <fo:root xmlns:fo="http://www.w3.org/1999/XSL/Format">      
		<fo:layout-master-set>
    <fo:simple-page-master master-name="A4" page-height="842px" page-width="595px" margin-top="10px" margin-bottom="10px" margin-left="10px" margin-right="10px">
      <fo:region-body margin-bottom="20mm"/>
      <fo:region-after region-name="footer" extent="10mm"/>
    </fo:simple-page-master>
    <fo:page-sequence-master master-name="document">
      <fo:repeatable-page-master-alternatives>
        <fo:conditional-page-master-reference master-reference="A4"/>
      </fo:repeatable-page-master-alternatives>
    </fo:page-sequence-master>
  </fo:layout-master-set>
  <fo:page-sequence master-reference="document" font-family="Arial">
    <fo:static-content flow-name="footer">
      <fo:block text-align="end"><fo:page-number/></fo:block>
    </fo:static-content>
          <fo:flow flow-name="xsl-region-body">		
						<fo:block font-size="20pt" text-align="center">Doložka právoplatnosti a vykonateľnosti</fo:block><fo:block color="white">|</fo:block><fo:block/>
					     				
				<xsl:apply-templates/>
			</fo:flow>
           </fo:page-sequence>
          </fo:root>
         </xsl:template>

			<xsl:template name="string-replace-all">
            <xsl:param name="text"/>
            <xsl:param name="replace"/>
            <xsl:param name="by"/>
            <xsl:choose>
            <xsl:when test="contains($text, $replace)">
            <xsl:value-of select="substring-before($text,$replace)"/>
            <xsl:value-of select="$by"/>
            <xsl:call-template name="string-replace-all">
            <xsl:with-param name="text" select="substring-after($text,$replace)"/>
            <xsl:with-param name="replace" select="$replace"/>
            <xsl:with-param name="by" select="$by"/>
            </xsl:call-template>
            </xsl:when>
            <xsl:otherwise>
            <xsl:value-of select="$text"/>
            </xsl:otherwise>
            </xsl:choose>
            </xsl:template>

			<xsl:template name="formatTimeTrimSeconds">
			<xsl:param name="time"/>
			<xsl:variable name="timeString" select="string($time)"/>
			<xsl:if test="$timeString != ''">
			<xsl:value-of select="substring($timeString, 1, 5)"/>
			</xsl:if>
			</xsl:template>

			<xsl:template name="formatTime">
			<xsl:param name="time"/>
			<xsl:variable name="timeString" select="string($time)"/>
			<xsl:if test="$timeString != ''">
			<xsl:value-of select="substring($timeString, 1, 8)"/>
			</xsl:if>
			</xsl:template>

			<xsl:template name="formatToSkDate">
			<xsl:param name="date"/>
			<xsl:variable name="dateString" select="string($date)"/>
			<xsl:choose>
			<xsl:when test="$dateString != '' and string-length($dateString)=10 and string(number(substring($dateString, 1, 4))) != 'NaN' ">
			<xsl:value-of select="concat(substring($dateString, 9, 2), '.', substring($dateString, 6, 2), '.', substring($dateString, 1, 4))"/>
			</xsl:when>
			<xsl:otherwise>
			<xsl:value-of select="$dateString"/>
			</xsl:otherwise>
			</xsl:choose>
			</xsl:template>

			<xsl:template name="formatToSkDateTime">
            <xsl:param name="dateTime"/>
            <xsl:variable name="dateTimeString" select="string($dateTime)"/>
            <xsl:choose>
            <xsl:when test="$dateTimeString!= '' and string-length($dateTimeString)&gt;18 and string(number(substring($dateTimeString, 1, 4))) != 'NaN' ">
            <xsl:value-of select="concat(substring($dateTimeString, 9, 2), '.', substring($dateTimeString, 6, 2), '.', substring($dateTimeString, 1, 4),' ', substring($dateTimeString, 12, 2),':', substring($dateTimeString, 15, 2))"/>
            </xsl:when>
            <xsl:otherwise>
            <xsl:value-of select="$dateTimeString"/>
            </xsl:otherwise>
            </xsl:choose>
            </xsl:template>

			<xsl:template name="formatToSkDateTimeSecond">
            <xsl:param name="dateTime"/>
            <xsl:variable name="dateTimeString" select="string($dateTime)"/>
            <xsl:choose>
            <xsl:when test="$dateTimeString!= '' and string-length($dateTimeString)&gt;18 and string(number(substring($dateTimeString, 1, 4))) != 'NaN' ">
            <xsl:value-of select="concat(substring($dateTimeString, 9, 2), '.', substring($dateTimeString, 6, 2), '.', substring($dateTimeString, 1, 4),' ', substring($dateTimeString, 12, 2),':', substring($dateTimeString, 15, 2),':', substring($dateTimeString, 18, 2))"/>
            </xsl:when>
            <xsl:otherwise>
            <xsl:value-of select="$dateTimeString"/>
            </xsl:otherwise>
            </xsl:choose>
            </xsl:template>
							<xsl:template match="egonp:sekciaDolozkaPravoplatnostiAVykonatelnosti">
<fo:block start-indent="5mm">
<fo:table space-before="2mm"><fo:table-column column-width="285px"/><fo:table-column/><fo:table-body><fo:table-row><fo:table-cell><fo:block>sekciaNazov</fo:block></fo:table-cell><fo:table-cell border-width="0.6pt" border-style="solid" background-color="white" padding="1pt"><fo:block><xsl:value-of select="egonp:sekciaNazov"/><fo:inline color="white">___</fo:inline></fo:block></fo:table-cell></fo:table-row></fo:table-body></fo:table><fo:block color="white">|</fo:block>
<xsl:apply-templates select="./egonp:TypDolozky"/>
</fo:block>
</xsl:template>
<xsl:template match="egonp:sekciaDolozkaPravoplatnostiAVykonatelnosti/egonp:TypDolozky">
<fo:block start-indent="5mm">
<fo:block background-color="black" color="white">Typ doložky</fo:block><fo:block color="white">|</fo:block><fo:table space-before="2mm"><fo:table-column column-width="285px"/><fo:table-column/><fo:table-body><fo:table-row><fo:table-cell><fo:block>Typ doložky:</fo:block></fo:table-cell></fo:table-row>

<fo:table-row>  
<fo:table-cell>
<fo:block>doložka právoplatnosti</fo:block>
</fo:table-cell>
<fo:table-cell>
<fo:block font-size="12pt">
<xsl:choose>
<xsl:when test="egonp:switchTypDolozky[text()='0']">
<fo:inline font-family="Wingdings"></fo:inline>
</xsl:when>
<xsl:otherwise>
<fo:inline font-family="Wingdings"></fo:inline>
</xsl:otherwise>
</xsl:choose>
</fo:block>
</fo:table-cell>
</fo:table-row>
<fo:table-row>  
<fo:table-cell>
<fo:block>doložka vykonateľnosti</fo:block>
</fo:table-cell>
<fo:table-cell>
<fo:block font-size="12pt">
<xsl:choose>
<xsl:when test="egonp:switchTypDolozky[text()='1']">
<fo:inline font-family="Wingdings"></fo:inline>
</xsl:when>
<xsl:otherwise>
<fo:inline font-family="Wingdings"></fo:inline>
</xsl:otherwise>
</xsl:choose>
</fo:block>
</fo:table-cell>
</fo:table-row>
<fo:table-row>  
<fo:table-cell>
<fo:block>doložka právoplatnosti a vykonateľnosti</fo:block>
</fo:table-cell>
<fo:table-cell>
<fo:block font-size="12pt">
<xsl:choose>
<xsl:when test="egonp:switchTypDolozky[text()='2']">
<fo:inline font-family="Wingdings"></fo:inline>
</xsl:when>
<xsl:otherwise>
<fo:inline font-family="Wingdings"></fo:inline>
</xsl:otherwise>
</xsl:choose>
</fo:block>
</fo:table-cell>
</fo:table-row></fo:table-body></fo:table><fo:block color="white">|</fo:block>
<fo:table space-before="2mm"><fo:table-column column-width="285px"/><fo:table-column/><fo:table-body><fo:table-row><fo:table-cell><fo:block>Číslo rozhodnutia:</fo:block></fo:table-cell><fo:table-cell border-width="0.6pt" border-style="solid" background-color="white" padding="1pt"><fo:block><xsl:call-template name="string-replace-all"><xsl:with-param name="text" select="egonp:cisloRozhodnutia"/><xsl:with-param name="replace" select="'%0A'"/><xsl:with-param name="by" select="'&#13;&#10;'"/></xsl:call-template><fo:inline color="white">___</fo:inline></fo:block></fo:table-cell></fo:table-row></fo:table-body></fo:table><fo:block color="white">|</fo:block>
<fo:table space-before="2mm"><fo:table-column column-width="285px"/><fo:table-column/><fo:table-body><fo:table-row><fo:table-cell><fo:block>Dátum vydania rozhodnutia:</fo:block></fo:table-cell><fo:table-cell border-width="0.6pt" border-style="solid" background-color="white" padding="1pt"><fo:block><xsl:call-template name="formatToSkDate"><xsl:with-param name="date" select="egonp:datumVydaniaRozhodnutia"/></xsl:call-template><fo:inline color="white">___</fo:inline></fo:block></fo:table-cell></fo:table-row></fo:table-body></fo:table><fo:block color="white">|</fo:block>
<fo:table space-before="2mm"><fo:table-column column-width="285px"/><fo:table-column/><fo:table-body><fo:table-row><fo:table-cell><fo:block>Dátum vytvorenia doložky:</fo:block></fo:table-cell><fo:table-cell border-width="0.6pt" border-style="solid" background-color="white" padding="1pt"><fo:block><xsl:call-template name="formatToSkDate"><xsl:with-param name="date" select="egonp:datumVytvoreniaDolozky"/></xsl:call-template><fo:inline color="white">___</fo:inline></fo:block></fo:table-cell></fo:table-row></fo:table-body></fo:table><fo:block color="white">|</fo:block>
<fo:table space-before="2mm"><fo:table-column column-width="285px"/><fo:table-column/><fo:table-body><fo:table-row><fo:table-cell><fo:block>Vytvoril:</fo:block></fo:table-cell><fo:table-cell border-width="0.6pt" border-style="solid" background-color="white" padding="1pt"><fo:block><xsl:call-template name="string-replace-all"><xsl:with-param name="text" select="egonp:vytvoril"/><xsl:with-param name="replace" select="'%0A'"/><xsl:with-param name="by" select="'&#13;&#10;'"/></xsl:call-template><fo:inline color="white">___</fo:inline></fo:block></fo:table-cell></fo:table-row></fo:table-body></fo:table><fo:block color="white">|</fo:block>
<xsl:apply-templates select="./egonp:sekciaRozhodnutieVydal"/>
<xsl:apply-templates select="./egonp:sekciaUdajeSpravoplatneniaRozhodnutia"/>
<xsl:apply-templates select="./egonp:sekciaUdajeVykonatelnostiRozhodnutia"/>
</fo:block>
</xsl:template>
<xsl:template match="egonp:sekciaDolozkaPravoplatnostiAVykonatelnosti/egonp:TypDolozky/egonp:sekciaRozhodnutieVydal">
<fo:block start-indent="5mm">
<fo:block background-color="black" color="white">Rozhodnutie vydal</fo:block><fo:block color="white">|</fo:block><fo:table space-before="2mm"><fo:table-column column-width="285px"/><fo:table-column/><fo:table-body><fo:table-row><fo:table-cell><fo:block>Ičo:</fo:block></fo:table-cell><fo:table-cell border-width="0.6pt" border-style="solid" background-color="white" padding="1pt"><fo:block><xsl:call-template name="string-replace-all"><xsl:with-param name="text" select="egonp:rozhodnutieVydalIco"/><xsl:with-param name="replace" select="'%0A'"/><xsl:with-param name="by" select="'&#13;&#10;'"/></xsl:call-template><fo:inline color="white">___</fo:inline></fo:block></fo:table-cell></fo:table-row></fo:table-body></fo:table><fo:block color="white">|</fo:block>
<fo:table space-before="2mm"><fo:table-column column-width="285px"/><fo:table-column/><fo:table-body><fo:table-row><fo:table-cell><fo:block>Názov:</fo:block></fo:table-cell><fo:table-cell border-width="0.6pt" border-style="solid" background-color="white" padding="1pt"><fo:block><xsl:call-template name="string-replace-all"><xsl:with-param name="text" select="egonp:rozhodnutieVydalNazov"/><xsl:with-param name="replace" select="'%0A'"/><xsl:with-param name="by" select="'&#13;&#10;'"/></xsl:call-template><fo:inline color="white">___</fo:inline></fo:block></fo:table-cell></fo:table-row></fo:table-body></fo:table><fo:block color="white">|</fo:block>
</fo:block>
</xsl:template>
<xsl:template match="egonp:sekciaDolozkaPravoplatnostiAVykonatelnosti/egonp:TypDolozky/egonp:sekciaUdajeSpravoplatneniaRozhodnutia">
<fo:block start-indent="5mm">
<fo:block background-color="black" color="white">Údaje správoplatnenia rozhodnutia</fo:block><fo:block color="white">|</fo:block><fo:table space-before="2mm"><fo:table-column column-width="285px"/><fo:table-column/><fo:table-body><fo:table-row><fo:table-cell><fo:block>Dátum nadobudnutia právoplatnosti:</fo:block></fo:table-cell><fo:table-cell border-width="0.6pt" border-style="solid" background-color="white" padding="1pt"><fo:block><xsl:call-template name="formatToSkDate"><xsl:with-param name="date" select="egonp:datumNadobudnutiaPravoplatnosti"/></xsl:call-template><fo:inline color="white">___</fo:inline></fo:block></fo:table-cell></fo:table-row></fo:table-body></fo:table><fo:block color="white">|</fo:block>
<fo:table space-before="2mm"><fo:table-column column-width="285px"/><fo:table-column/><fo:table-body><fo:table-row><fo:table-cell><fo:block>Právoplatnosť vyznačená pre:</fo:block></fo:table-cell></fo:table-row>

<fo:table-row>  
<fo:table-cell>
<fo:block>rozhodnutie v plnom znení</fo:block>
</fo:table-cell>
<fo:table-cell>
<fo:block font-size="12pt">
<xsl:choose>
<xsl:when test="egonp:pravoplatnostVyznacenaPre[text()='0']">
<fo:inline font-family="Wingdings"></fo:inline>
</xsl:when>
<xsl:otherwise>
<fo:inline font-family="Wingdings"></fo:inline>
</xsl:otherwise>
</xsl:choose>
</fo:block>
</fo:table-cell>
</fo:table-row>
<fo:table-row>  
<fo:table-cell>
<fo:block>časť rozhodnutia</fo:block>
</fo:table-cell>
<fo:table-cell>
<fo:block font-size="12pt">
<xsl:choose>
<xsl:when test="egonp:pravoplatnostVyznacenaPre[text()='1']">
<fo:inline font-family="Wingdings"></fo:inline>
</xsl:when>
<xsl:otherwise>
<fo:inline font-family="Wingdings"></fo:inline>
</xsl:otherwise>
</xsl:choose>
</fo:block>
</fo:table-cell>
</fo:table-row></fo:table-body></fo:table><fo:block color="white">|</fo:block>
<xsl:apply-templates select="./egonp:sekciaSpravoplatnenaCast"/>
</fo:block>
</xsl:template>
<xsl:template match="egonp:sekciaDolozkaPravoplatnostiAVykonatelnosti/egonp:TypDolozky/egonp:sekciaUdajeSpravoplatneniaRozhodnutia/egonp:sekciaSpravoplatnenaCast">
<fo:block start-indent="5mm">
<fo:block background-color="black" color="white">Správoplatnená časť</fo:block><fo:block color="white">|</fo:block><fo:table space-before="2mm"><fo:table-column column-width="285px"/><fo:table-column/><fo:table-body><fo:table-row><fo:table-cell><fo:block>Text pre vymedzenie právoplatnosti k výrokovým častiam:</fo:block></fo:table-cell><fo:table-cell height="100px" border-width="0.6pt" border-style="solid" background-color="white" padding="1pt"><fo:block hyphenate="true" linefeed-treatment="preserve"><xsl:call-template name="string-replace-all"><xsl:with-param name="text" select="egonp:textPreVymedzeniePravoplatnosti"/><xsl:with-param name="replace" select="'%0A'"/><xsl:with-param name="by" select="'&#13;&#10;'"/></xsl:call-template></fo:block></fo:table-cell></fo:table-row></fo:table-body></fo:table><fo:block color="white">|</fo:block>
</fo:block>
</xsl:template>
<xsl:template match="egonp:sekciaDolozkaPravoplatnostiAVykonatelnosti/egonp:TypDolozky/egonp:sekciaUdajeVykonatelnostiRozhodnutia">
<fo:block start-indent="5mm">
<fo:block background-color="black" color="white">Údaje vykonateľnosti rozhodnutia</fo:block><fo:block color="white">|</fo:block><fo:table space-before="2mm"><fo:table-column column-width="285px"/><fo:table-column/><fo:table-body><fo:table-row><fo:table-cell><fo:block>Dátum nadobudnutia vykonateľnosti:</fo:block></fo:table-cell><fo:table-cell border-width="0.6pt" border-style="solid" background-color="white" padding="1pt"><fo:block><xsl:call-template name="formatToSkDate"><xsl:with-param name="date" select="egonp:datumNadobudnutiaVykonatelnosti"/></xsl:call-template><fo:inline color="white">___</fo:inline></fo:block></fo:table-cell></fo:table-row></fo:table-body></fo:table><fo:block color="white">|</fo:block>
<fo:table space-before="2mm"><fo:table-column column-width="285px"/><fo:table-column/><fo:table-body><fo:table-row><fo:table-cell><fo:block>Vykonateľnosť vyznačená pre:</fo:block></fo:table-cell></fo:table-row>

<fo:table-row>  
<fo:table-cell>
<fo:block>rozhodnutie v plnom znení</fo:block>
</fo:table-cell>
<fo:table-cell>
<fo:block font-size="12pt">
<xsl:choose>
<xsl:when test="egonp:vykonatelnostVyznacenaPre[text()='0']">
<fo:inline font-family="Wingdings"></fo:inline>
</xsl:when>
<xsl:otherwise>
<fo:inline font-family="Wingdings"></fo:inline>
</xsl:otherwise>
</xsl:choose>
</fo:block>
</fo:table-cell>
</fo:table-row>
<fo:table-row>  
<fo:table-cell>
<fo:block>časť rozhodnutia</fo:block>
</fo:table-cell>
<fo:table-cell>
<fo:block font-size="12pt">
<xsl:choose>
<xsl:when test="egonp:vykonatelnostVyznacenaPre[text()='1']">
<fo:inline font-family="Wingdings"></fo:inline>
</xsl:when>
<xsl:otherwise>
<fo:inline font-family="Wingdings"></fo:inline>
</xsl:otherwise>
</xsl:choose>
</fo:block>
</fo:table-cell>
</fo:table-row></fo:table-body></fo:table><fo:block color="white">|</fo:block>
<xsl:apply-templates select="./egonp:sekciaVykonatelnaCast"/>
</fo:block>
</xsl:template>
<xsl:template match="egonp:sekciaDolozkaPravoplatnostiAVykonatelnosti/egonp:TypDolozky/egonp:sekciaUdajeVykonatelnostiRozhodnutia/egonp:sekciaVykonatelnaCast">
<fo:block start-indent="5mm">
<fo:block background-color="black" color="white">Vykonateľná časť</fo:block><fo:block color="white">|</fo:block><fo:table space-before="2mm"><fo:table-column column-width="285px"/><fo:table-column/><fo:table-body><fo:table-row><fo:table-cell><fo:block>Text pre vymedzenie vykonateľnosti k výrokovým častiam:</fo:block></fo:table-cell><fo:table-cell height="100px" border-width="0.6pt" border-style="solid" background-color="white" padding="1pt"><fo:block hyphenate="true" linefeed-treatment="preserve"><xsl:call-template name="string-replace-all"><xsl:with-param name="text" select="egonp:textPreVymedzenieVykonatelnosti"/><xsl:with-param name="replace" select="'%0A'"/><xsl:with-param name="by" select="'&#13;&#10;'"/></xsl:call-template></fo:block></fo:table-cell></fo:table-row></fo:table-body></fo:table><fo:block color="white">|</fo:block>
</fo:block>
</xsl:template>
	
        </xsl:stylesheet>
