﻿<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="1.0"  xmlns:xsl="http://www.w3.org/1999/XSL/Transform"  xmlns:egonp="http://schemas.gov.sk/form/50349287.DolozkaPravoplatnostiAVykonatelnosti.sk/1.0" exclude-result-prefixes="egonp">
<xsl:output method="html" doctype-system="http://www.w3.org/TR/html4/loose.dtd" doctype-public="-//W3C//DTD HTML 4.01 Transitional//EN" indent="no" omit-xml-declaration="yes"/>
<xsl:template match="/">
<html>
<head>
<meta http-equiv="X-UA-Compatible" content="IE=8" />
<title>Doložka právoplatnosti a vykonateľnosti</title>
<meta http-equiv="Content-Type" content="text/html; charset=UTF-8"/>
<meta name="language" content="sk-SK"/>
<style type="text/css">
body { 
	font-family: 'Open Sans', 'Segoe UI', 'Trebuchet MS', 'Geneva CE', lucida, sans-serif;
	background : #ffffff !important ;
}
.ui-tabs {
	padding: .2em;
	position: relative;
	zoom: 1;
}								
.clear { clear: both; height: 0;}
.layoutMain {
	margin: 0px auto;
	padding: 5px 5px 5px 5px;	
}				
.layoutRow { margin-bottom: 5px; }				
.caption { /*width: 100%; border-bottom: solid 1px black;*/ }
.nocaption &gt; .caption { border: 0px !important; }
.nocaption &gt; .caption span {
	background: none !important;
	display: none;
} 
.caption .title { padding-left: 5px; }
.headercorrection {	
	margin: 0px;
    font-size : 1em;
    font-weight: bold;
}				
.labelVis {
	float: left;
	font-weight: bold;
	font-family: 'Open Sans', 'Segoe UI', 'Trebuchet MS', 'Geneva CE', lucida, sans-serif;
	line-height: 25px;
	margin: 0px 18px 0px 0px;
	padding-left: 3px;
	width: 190px;
	word-wrap: break-word;
    font-size: 0.8em;
}
.contentVis {    	     
	float: left;	
	line-height: 25px;
	margin: 0px;
	padding: 0px;
	vertical-align: top;
    font-size: 0.75em;			
}
.wordwrap { 
    white-space: pre-wrap;      
    white-space: -moz-pre-wrap; 
    white-space: -pre-wrap;     
    white-space: -o-pre-wrap;   
    word-wrap: break-word;      
}	
.ui-widget-content {
	background : 50% 50% repeat-x #ffffff;
	border : #d4d4d4 solid 2px;
	color : #4f4e4e;
	border-radius : 3px;
}
.ui-widget-header {
	cursor : pointer;
	font-size : 0.8em;
	color : #494949;
	padding-left : 2px;
	border : #eae9e8 solid 1px;
	background-color : #eae9e8;
	margin-bottom: 3px;
	border-radius : 3px;
}			
</style>
</head>
<body>
<div id="main" class="layoutMain">
<xsl:apply-templates/>
</div>
</body>
</html>
</xsl:template>
<xsl:template match="/egonp:sekciaDolozkaPravoplatnostiAVykonatelnosti">
<div class="layoutRow ui-tabs ui-widget-content" >
<div class="caption ui-widget-header">
<div class="headercorrection">Doložka právoplatnosti a vykonateľnosti</div>
</div>
<xsl:apply-templates select="./egonp:sekciaNazov"/>
<xsl:apply-templates select="./egonp:TypDolozky"/>
</div>
</xsl:template>
<xsl:template match="/egonp:sekciaDolozkaPravoplatnostiAVykonatelnosti/egonp:TypDolozky">
<div class="layoutRow ui-tabs ui-widget-content" >
<div class="caption ui-widget-header">
<div class="headercorrection">Typ doložky</div>
</div>
<xsl:apply-templates select="./egonp:switchTypDolozky"/>
<xsl:apply-templates select="./egonp:cisloRozhodnutia"/>
<xsl:apply-templates select="./egonp:datumVydaniaRozhodnutia"/>
<xsl:apply-templates select="./egonp:datumVytvoreniaDolozky"/>
<xsl:apply-templates select="./egonp:vytvoril"/>
<xsl:apply-templates select="./egonp:sekciaRozhodnutieVydal"/>
<xsl:apply-templates select="./egonp:sekciaUdajeSpravoplatneniaRozhodnutia"/>
<xsl:apply-templates select="./egonp:sekciaUdajeVykonatelnostiRozhodnutia"/>
</div>
</xsl:template>
<xsl:template match="/egonp:sekciaDolozkaPravoplatnostiAVykonatelnosti/egonp:TypDolozky/egonp:sekciaRozhodnutieVydal">
<div class="layoutRow ui-tabs ui-widget-content" >
<div class="caption ui-widget-header">
<div class="headercorrection">Rozhodnutie vydal</div>
</div>
<xsl:apply-templates select="./egonp:rozhodnutieVydalIco"/>
<xsl:apply-templates select="./egonp:rozhodnutieVydalNazov"/>
</div>
</xsl:template>
<xsl:template match="/egonp:sekciaDolozkaPravoplatnostiAVykonatelnosti/egonp:TypDolozky/egonp:sekciaUdajeSpravoplatneniaRozhodnutia">
<div class="layoutRow ui-tabs ui-widget-content" >
<div class="caption ui-widget-header">
<div class="headercorrection">Údaje správoplatnenia rozhodnutia</div>
</div>
<xsl:apply-templates select="./egonp:datumNadobudnutiaPravoplatnosti"/>
<xsl:apply-templates select="./egonp:pravoplatnostVyznacenaPre"/>
<xsl:apply-templates select="./egonp:sekciaSpravoplatnenaCast"/>
</div>
</xsl:template>
<xsl:template match="/egonp:sekciaDolozkaPravoplatnostiAVykonatelnosti/egonp:TypDolozky/egonp:sekciaUdajeSpravoplatneniaRozhodnutia/egonp:sekciaSpravoplatnenaCast">
<div class="layoutRow ui-tabs ui-widget-content" >
<div class="caption ui-widget-header">
<div class="headercorrection">Správoplatnená časť</div>
</div>
<xsl:apply-templates select="./egonp:textPreVymedzeniePravoplatnosti"/>
</div>
</xsl:template>
<xsl:template match="/egonp:sekciaDolozkaPravoplatnostiAVykonatelnosti/egonp:TypDolozky/egonp:sekciaUdajeVykonatelnostiRozhodnutia">
<div class="layoutRow ui-tabs ui-widget-content" >
<div class="caption ui-widget-header">
<div class="headercorrection">Údaje vykonateľnosti rozhodnutia</div>
</div>
<xsl:apply-templates select="./egonp:datumNadobudnutiaVykonatelnosti"/>
<xsl:apply-templates select="./egonp:vykonatelnostVyznacenaPre"/>
<xsl:apply-templates select="./egonp:sekciaVykonatelnaCast"/>
</div>
</xsl:template>
<xsl:template match="/egonp:sekciaDolozkaPravoplatnostiAVykonatelnosti/egonp:TypDolozky/egonp:sekciaUdajeVykonatelnostiRozhodnutia/egonp:sekciaVykonatelnaCast">
<div class="layoutRow ui-tabs ui-widget-content" >
<div class="caption ui-widget-header">
<div class="headercorrection">Vykonateľná časť</div>
</div>
<xsl:apply-templates select="./egonp:textPreVymedzenieVykonatelnosti"/>
</div>
</xsl:template>
<xsl:template match="egonp:sekciaDolozkaPravoplatnostiAVykonatelnosti/egonp:sekciaNazov">
<xsl:if test="./text()">
<div><label class="labelVis">sekciaNazov: </label><span class="contentVis wordwrap"><xsl:value-of select="."/></span></div><div class="clear">&#xa0;</div></xsl:if>
</xsl:template>
<xsl:template match="egonp:sekciaDolozkaPravoplatnostiAVykonatelnosti/egonp:TypDolozky/egonp:switchTypDolozky">
<xsl:if test="./text()">
<div><label class="labelVis">Typ doložky: </label><span class="contentVis wordwrap"><xsl:choose><xsl:when test=".='0'"><xsl:text>doložka pr&#225;voplatnosti</xsl:text></xsl:when><xsl:when test=".='1'"><xsl:text>doložka vykonateľnosti</xsl:text></xsl:when><xsl:when test=".='2'"><xsl:text>doložka pr&#225;voplatnosti a vykonateľnosti</xsl:text></xsl:when><xsl:otherwise><xsl:value-of select="."/></xsl:otherwise></xsl:choose></span></div><div class="clear">&#xa0;</div></xsl:if>
</xsl:template>
<xsl:template match="egonp:sekciaDolozkaPravoplatnostiAVykonatelnosti/egonp:TypDolozky/egonp:cisloRozhodnutia">
<xsl:if test="./text()">
<div><label class="labelVis">Číslo rozhodnutia: </label><span class="contentVis wordwrap"><xsl:call-template name="string-replace-all"><xsl:with-param name="text" select="." /><xsl:with-param name="replace" select="'%0A'" /><xsl:with-param name="by" select="'&#13;&#10;'" /></xsl:call-template></span></div><div class="clear">&#xa0;</div></xsl:if>
</xsl:template>
<xsl:template match="egonp:sekciaDolozkaPravoplatnostiAVykonatelnosti/egonp:TypDolozky/egonp:datumVydaniaRozhodnutia">
<xsl:if test="./text()">
<div><label class="labelVis">Dátum vydania rozhodnutia: </label><span class="contentVis wordwrap"><xsl:call-template name="formatToSkDate"><xsl:with-param name="date" select="." /></xsl:call-template></span></div><div class="clear">&#xa0;</div></xsl:if>
</xsl:template>
<xsl:template match="egonp:sekciaDolozkaPravoplatnostiAVykonatelnosti/egonp:TypDolozky/egonp:datumVytvoreniaDolozky">
<xsl:if test="./text()">
<div><label class="labelVis">Dátum vytvorenia doložky: </label><span class="contentVis wordwrap"><xsl:call-template name="formatToSkDate"><xsl:with-param name="date" select="." /></xsl:call-template></span></div><div class="clear">&#xa0;</div></xsl:if>
</xsl:template>
<xsl:template match="egonp:sekciaDolozkaPravoplatnostiAVykonatelnosti/egonp:TypDolozky/egonp:vytvoril">
<xsl:if test="./text()">
<div><label class="labelVis">Vytvoril: </label><span class="contentVis wordwrap"><xsl:call-template name="string-replace-all"><xsl:with-param name="text" select="." /><xsl:with-param name="replace" select="'%0A'" /><xsl:with-param name="by" select="'&#13;&#10;'" /></xsl:call-template></span></div><div class="clear">&#xa0;</div></xsl:if>
</xsl:template>
<xsl:template match="egonp:sekciaDolozkaPravoplatnostiAVykonatelnosti/egonp:TypDolozky/egonp:sekciaRozhodnutieVydal/egonp:rozhodnutieVydalIco">
<xsl:if test="./text()">
<div><label class="labelVis">Ičo: </label><span class="contentVis wordwrap"><xsl:call-template name="string-replace-all"><xsl:with-param name="text" select="." /><xsl:with-param name="replace" select="'%0A'" /><xsl:with-param name="by" select="'&#13;&#10;'" /></xsl:call-template></span></div><div class="clear">&#xa0;</div></xsl:if>
</xsl:template>
<xsl:template match="egonp:sekciaDolozkaPravoplatnostiAVykonatelnosti/egonp:TypDolozky/egonp:sekciaRozhodnutieVydal/egonp:rozhodnutieVydalNazov">
<xsl:if test="./text()">
<div><label class="labelVis">Názov: </label><span class="contentVis wordwrap"><xsl:call-template name="string-replace-all"><xsl:with-param name="text" select="." /><xsl:with-param name="replace" select="'%0A'" /><xsl:with-param name="by" select="'&#13;&#10;'" /></xsl:call-template></span></div><div class="clear">&#xa0;</div></xsl:if>
</xsl:template>
<xsl:template match="egonp:sekciaDolozkaPravoplatnostiAVykonatelnosti/egonp:TypDolozky/egonp:sekciaUdajeSpravoplatneniaRozhodnutia/egonp:datumNadobudnutiaPravoplatnosti">
<xsl:if test="./text()">
<div><label class="labelVis">Dátum nadobudnutia právoplatnosti: </label><span class="contentVis wordwrap"><xsl:call-template name="formatToSkDate"><xsl:with-param name="date" select="." /></xsl:call-template></span></div><div class="clear">&#xa0;</div></xsl:if>
</xsl:template>
<xsl:template match="egonp:sekciaDolozkaPravoplatnostiAVykonatelnosti/egonp:TypDolozky/egonp:sekciaUdajeSpravoplatneniaRozhodnutia/egonp:pravoplatnostVyznacenaPre">
<xsl:if test="./text()">
<div><label class="labelVis">Právoplatnosť vyznačená pre: </label><span class="contentVis wordwrap"><xsl:choose><xsl:when test=".='0'"><xsl:text>rozhodnutie v plnom znen&#237;</xsl:text></xsl:when><xsl:when test=".='1'"><xsl:text>časť rozhodnutia</xsl:text></xsl:when><xsl:otherwise><xsl:value-of select="."/></xsl:otherwise></xsl:choose></span></div><div class="clear">&#xa0;</div></xsl:if>
</xsl:template>
<xsl:template match="egonp:sekciaDolozkaPravoplatnostiAVykonatelnosti/egonp:TypDolozky/egonp:sekciaUdajeSpravoplatneniaRozhodnutia/egonp:sekciaSpravoplatnenaCast/egonp:textPreVymedzeniePravoplatnosti">
<xsl:if test="./text()">
<div><label class="labelVis">Text pre vymedzenie právoplatnosti k výrokovým častiam: </label><span class="contentVis wordwrap"><xsl:call-template name="string-replace-all"><xsl:with-param name="text" select="." /><xsl:with-param name="replace" select="'%0A'" /><xsl:with-param name="by" select="'&#13;&#10;'" /></xsl:call-template></span></div><div class="clear">&#xa0;</div></xsl:if>
</xsl:template>
<xsl:template match="egonp:sekciaDolozkaPravoplatnostiAVykonatelnosti/egonp:TypDolozky/egonp:sekciaUdajeVykonatelnostiRozhodnutia/egonp:datumNadobudnutiaVykonatelnosti">
<xsl:if test="./text()">
<div><label class="labelVis">Dátum nadobudnutia vykonateľnosti: </label><span class="contentVis wordwrap"><xsl:call-template name="formatToSkDate"><xsl:with-param name="date" select="." /></xsl:call-template></span></div><div class="clear">&#xa0;</div></xsl:if>
</xsl:template>
<xsl:template match="egonp:sekciaDolozkaPravoplatnostiAVykonatelnosti/egonp:TypDolozky/egonp:sekciaUdajeVykonatelnostiRozhodnutia/egonp:vykonatelnostVyznacenaPre">
<xsl:if test="./text()">
<div><label class="labelVis">Vykonateľnosť vyznačená pre: </label><span class="contentVis wordwrap"><xsl:choose><xsl:when test=".='0'"><xsl:text>rozhodnutie v plnom znen&#237;</xsl:text></xsl:when><xsl:when test=".='1'"><xsl:text>časť rozhodnutia</xsl:text></xsl:when><xsl:otherwise><xsl:value-of select="."/></xsl:otherwise></xsl:choose></span></div><div class="clear">&#xa0;</div></xsl:if>
</xsl:template>
<xsl:template match="egonp:sekciaDolozkaPravoplatnostiAVykonatelnosti/egonp:TypDolozky/egonp:sekciaUdajeVykonatelnostiRozhodnutia/egonp:sekciaVykonatelnaCast/egonp:textPreVymedzenieVykonatelnosti">
<xsl:if test="./text()">
<div><label class="labelVis">Text pre vymedzenie vykonateľnosti k výrokovým častiam: </label><span class="contentVis wordwrap"><xsl:call-template name="string-replace-all"><xsl:with-param name="text" select="." /><xsl:with-param name="replace" select="'%0A'" /><xsl:with-param name="by" select="'&#13;&#10;'" /></xsl:call-template></span></div><div class="clear">&#xa0;</div></xsl:if>
</xsl:template>
<xsl:template name="formatToSkDate">
<xsl:param name="date" />
<xsl:variable name="dateString" select="string($date)" />
<xsl:choose>
<xsl:when test="$dateString != '' and string-length($dateString)=10 and string(number(substring($dateString, 1, 4))) != 'NaN' ">
<xsl:value-of select="concat(substring($dateString, 9, 2), '.', substring($dateString, 6, 2), '.', substring($dateString, 1, 4))" />
</xsl:when>
<xsl:otherwise>
<xsl:value-of select="$dateString"></xsl:value-of>
</xsl:otherwise>
</xsl:choose>
</xsl:template>
<xsl:template name="booleanCheckboxToString">
<xsl:param name="boolValue" />
<xsl:variable name="boolValueString" select="string($boolValue)" />
<xsl:choose>
<xsl:when test="$boolValueString = 'true' ">
<xsl:text>Áno</xsl:text>
</xsl:when>
<xsl:when test="$boolValueString = 'false' ">
<xsl:text>Nie</xsl:text>
</xsl:when>
<xsl:when test="$boolValueString = '1' ">
<xsl:text>Áno</xsl:text>
</xsl:when>
<xsl:when test="$boolValueString = '0' ">
<xsl:text>Nie</xsl:text>
</xsl:when>
<xsl:otherwise>
<xsl:value-of select="$boolValueString"></xsl:value-of>
</xsl:otherwise>
</xsl:choose>
</xsl:template>
<xsl:template name="formatTimeTrimSeconds">
<xsl:param name="time" />
<xsl:variable name="timeString" select="string($time)" />
<xsl:if test="$timeString != ''">
<xsl:value-of select="substring($timeString, 1, 5)" />
</xsl:if>
</xsl:template>
<xsl:template name="formatTime">
<xsl:param name="time" />
<xsl:variable name="timeString" select="string($time)" />
<xsl:if test="$timeString != ''">
<xsl:value-of select="substring($timeString, 1, 8)" />
</xsl:if>
</xsl:template>
<xsl:template name="string-replace-all">
<xsl:param name="text"/>
<xsl:param name="replace"/>
<xsl:param name="by"/>
<xsl:choose>
<xsl:when test="contains($text, $replace)">
<xsl:value-of select="substring-before($text,$replace)"/>
<xsl:value-of select="$by"/>
<xsl:call-template name="string-replace-all">
<xsl:with-param name="text" select="substring-after($text,$replace)"/>
<xsl:with-param name="replace" select="$replace"/>
<xsl:with-param name="by" select="$by" />
</xsl:call-template>
</xsl:when>
<xsl:otherwise>
<xsl:value-of select="$text"/>
</xsl:otherwise>
</xsl:choose>
</xsl:template>
<xsl:template name="formatToSkDateTime">
<xsl:param name="dateTime" />
<xsl:variable name="dateTimeString" select="string($dateTime)" />
<xsl:choose>
<xsl:when test="$dateTimeString!= '' and string-length($dateTimeString)>18 and string(number(substring($dateTimeString, 1, 4))) != 'NaN' ">
<xsl:value-of select="concat(substring($dateTimeString, 9, 2), '.', substring($dateTimeString, 6, 2), '.', substring($dateTimeString, 1, 4),' ', substring($dateTimeString, 12, 2),':', substring($dateTimeString, 15, 2))" />
</xsl:when>
<xsl:otherwise>
<xsl:value-of select="$dateTimeString"></xsl:value-of>
</xsl:otherwise>
</xsl:choose>
</xsl:template>
<xsl:template name="formatToSkDateTimeSecond">
<xsl:param name="dateTime" />
<xsl:variable name="dateTimeString" select="string($dateTime)" />
<xsl:choose>
<xsl:when test="$dateTimeString!= '' and string-length($dateTimeString)>18 and string(number(substring($dateTimeString, 1, 4))) != 'NaN' ">
<xsl:value-of select="concat(substring($dateTimeString, 9, 2), '.', substring($dateTimeString, 6, 2), '.', substring($dateTimeString, 1, 4),' ', substring($dateTimeString, 12, 2),':', substring($dateTimeString, 15, 2),':', substring($dateTimeString, 18, 2))" />
</xsl:when>
<xsl:otherwise>
<xsl:value-of select="$dateTimeString"></xsl:value-of>
</xsl:otherwise>
</xsl:choose>
</xsl:template>
</xsl:stylesheet>

